unit UVPlan_mX4Tester_QRCode;
//Unit View Plans
//This unit allows plans to be viewed.
//https://github.com/foxitsoftware/DelphiZXingQRCode/blob/master/Source/DelphiZXIngQRCode.pas

//{$MODE Delphi}

interface

{uses
  LCLIntf, LCLType, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, neuralplanbuilder;   }               

type
  TFormViewPlans = {class(}TForm;
  var
    Image1: TImage;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    procedure TFormViewPlansFormCreate(Sender: TObject);
  //private
    { Private declarations }
  //public
    { Public declarations }
  var
    S:array[0..4] of TShape;
        procedure TFormViewPlansLine(X1,Y1,X2,Y2:extended;cor:TColor);
        procedure TFormViewPlansClear;
        procedure TFormViewPlansDefinePos(X1,Y1:extended;P:byte);
        procedure TFormViewPlansShowPlan(var P:TPlan; L:extended);
        procedure TFormViewPlansShowPlanActionStateList(var V:TActionStateList; L:extended);
  //end;

var
  FormViewPlans: TFormViewPlans;

implementation

procedure TFormViewPlansLine(X1,Y1,X2,Y2:extended;cor:TColor);
begin
Image1.Canvas.Pen.Color := cor;
Image1.Canvas.MoveTo(round(X1*(Image1.Width-10)),round(Y1*(Image1.Height-10)));
Image1.Canvas.LineTo(round(X2*(Image1.Width-10)),round(Y2*(Image1.Height-10)));
end;

procedure TFormViewPlansClear;
begin
Image1.Canvas.Brush.Color := clwhite;
Image1.Canvas.FillRect(Rect(0,0,Image1.Width,Image1.Height));
end;

procedure TFormViewPlansDefinePos(X1,Y1:extended;P:byte);
begin
S[P].Left:=round(X1*(Image1.Width-10));
S[P].Top:=round(Y1*(Image1.Height-10));
end;

procedure TFormViewPlansShowPlanActionStateList(var V:TActionStateList; L:extended);
var R:longint;
    X1,Y1,X2,Y2:extended;
    P: TActionStateList;  PL: array[0..400-1] of TNeuralState2;
    //J: TJSONData;

begin
        PL:= V.liststates;
               for R:=0 to V.NumStates-2
                   do begin
                      //X1:=(V.ListStates[R][1]-1)/L;
                      X1:=(PL[R][1]-1)/L;
                      Y1:=(PL[R][2]-1)/L;
                      X2:=(PL[R+1][1]-1)/L;
                      Y2:=(PL[R+1][2]-1)/L;
                      if PL[R][3]=0
                         then TFormViewPlansLine(X1,Y1,X2,Y2,clBlack)
                         else TFormViewPlansLine(X1,Y1,X2,Y2,clRed) //}
                      end;
end;

procedure TFormViewPlansShowPlan(var P:TPlan; L:extended);
var  FPlan: TActionStateList;
begin
  FPlan:=  P.FPlan;
  //ShowPlanActionStateList(P.FPlan,L);
  TFormViewPlansShowPlanActionStateList(FPlan,L);
end;

//{$R *.lfm}

procedure TFormViewPlansFormCreate(Sender: TObject);
begin
   S[0]:=Shape1;
   S[1]:=Shape2;
   S[2]:=Shape3;
   S[3]:=Shape4;
   S[4]:=Shape5;
end;

var PaintBox1:TPaintBox; QRCodeBitmap: TBitmap;

procedure TForm1PaintBox1Paint(Sender: TObject);
var
  Scale: Double;
begin
  PaintBox1.Canvas.Brush.Color := clWhite;
  PaintBox1.Canvas.FillRect(Rect(0, 0, PaintBox1.Width, PaintBox1.Height));
  if ((QRCodeBitmap.Width > 0) and (QRCodeBitmap.Height > 0)) then
  begin
    if (PaintBox1.Width < PaintBox1.Height) then begin
      Scale := PaintBox1.Width / QRCodeBitmap.Width;
    end else begin
      Scale := PaintBox1.Height / QRCodeBitmap.Height;
    end;
    PaintBox1.Canvas.StretchDraw(Rect(0,0, Trunc(Scale * QRCodeBitmap.Width), 
                             Trunc(Scale * QRCodeBitmap.Height)), QRCodeBitmap);
  end;
end;

var myplans: TPlansArray; mycompo: TCompositePlan;  myplan: TPlan;
   bb: byte;
    ms: TMemoryStream;
  s1, s2: string;
  i: Integer;   afrm: TForm;  ImgSample, ImgSample2: TImage; row, Column: Integer;
  QRCode : TDelphiZXingQRCode; //QRCodeBitmap: TBitmap; PaintBox1:TPaintBox;

begin //@main

  mycompo:= TCompositePlan.create;
  
  myplan:= TPlan.create;
  //mycompo.plans2[0]:= myplan;
  myplans:= mycompo.plans;
  myplans[0]:= myplan;
  myplans[1]:= myplan;
  with TCompositePlan.create do begin
    LastUsedPlan;
    plans:= myplans;
     //plans2[0]:= myplan;
    //plans2[1]:= myplan;
    //plans2[1]:= myplan as Tplan;
    //plans2[1]:= myplan;
    writeln(objtostr(myplans[0]));
    writeln(objtostr(myplans[1]));
    //plans2[0]:= myplans[0];
    //writeln(objtostr(plans2[0]));
     //writeln(itoa(plans2[0]));
     //myplan:= TPlan(plans2[0]);
    //plans[1]
    free;
  end; 
  mycompo.Free; 
  myplan.Free;
  bb:= 4
  incb2(bb,6)
  writeln(itoa(bb))
  writeln(itoa(exit2(78)));
  
  afrm:= TForm.create(self);
 afrm.setbounds(0,0,500,500)
 afrm.icon.loadfromresourcename(hinstance, 'XFAVICON');
 afrm.show; 
  
  ImgSample:= TImage.create(afrm)
  with imgsample do begin
   parent:= afrm;
   setbounds( 248, 20, 379, 305)
   Anchors := [akLeft, akTop, akRight, akBottom]
    //Stretch := True
  end;
  
  ImgSample2:= TImage.create(afrm)
  with imgsample2 do begin
   parent:= afrm;
   setbounds( 24, 234, 379, 305)
   Anchors := [akLeft, akTop, akRight, akBottom]
    //Stretch := True
  end;
  
  //procedure CreateQRCodeBMP(const AText: string; const ABitmapStream: TStream;
  //const ALevel: Byte = QR_ECLEVEL_M; const ASize: Integer = 3);
  
  {const
  QR_ECLEVEL_L    = 0;
  QR_ECLEVEL_M    = 1;
  QR_ECLEVEL_Q    = 2;
  QR_ECLEVEL_H    = 3;   }

   //https://github.com/foxitsoftware/DelphiZXingQRCode/blob/master/TestApp/DelphiZXingQRCodeTestAppMainForm.pas
 { ms := TMemoryStream.Create;
  try
    //s := mmoText.Text;
    //s2 := 'maXbox4 dhdejjs s skdk fhdhh djdj 54 djj34';
    s2 := 'maXbox4';
    CreateQRCodeBMP(s2, ms, QR_ECLEVEL_L, 10);            
    ms.Position := 0;
    ImgSample.Picture.Bitmap.LoadFromStream(ms);
    ms.clear;
    CreateQRCodeBMP(s2, ms, QR_ECLEVEL_M, 10);            
    ms.Position := 0;
    ImgSample2.Picture.Bitmap.LoadFromStream(ms);
  finally
    ms.Free;
  end;  }
  
  //CreateQRCodeBMP
  //https://github.com/foxitsoftware/DelphiZXingQRCode/tree/master/TestApp
  QRCode := TDelphiZXingQRCode.Create;
  QRCodeBitmap := TBitmap.Create;
  afrm.Update;
  try
    QRCode.Data := 'maXbox4';
    QRCode.Encoding := qrcAuto; //qrcAlphanumeric; //TQRCodeEncoding(qrcAlphanumeric);
    //QRCode.QuietZone := StrToIntDef('edtQuietZone.Text', 4);
    QRCodeBitmap.SetSize(QRCode.Rows, QRCode.Columns);
    PaintBox1:= TPaintBox.create(afrm);
    PaintBox1.parent:= afrm;
     PaintBox1.setBounds( 196,32, 230, 242)
     PaintBox1.Anchors := [akLeft, akTop, akRight, akBottom];
      PaintBox1.OnPaint:= @TForm1PaintBox1Paint;
    //PaintBox1.ExplicitWidth := 331
    //PaintBox1.ExplicitHeight := 260
 
    for Row := 0 to QRCode.Rows - 1 do begin
      for Column := 0 to QRCode.Columns - 1 do begin
        if (QRCode.IsBlack[Row, Column]) then begin
          QRCodeBitmap.Canvas.Pixels[Column, Row]:= clBlack;
        end else begin
          QRCodeBitmap.Canvas.Pixels[Column, Row]:= clWhite;
        end;
      end;
    end;
  finally
    QRCode.Free;
  end;
  PaintBox1.Repaint;
  //QRCode.Free;
    
End.
