unit URobo2_mX4_EKON20_Update;

interface

{uses   #sign:0 Max: MAXBOX10: 20/05/2023 23:18:19 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;   }   //#locs:271

Const
  maxpoints=1000;
  sleepms=40;  {milliseconds (ms) delay between points}
  MAPPATH = 'examples\667_roboline_outdoor_layer5.bmp';
  
 // mapboxAPIMapOutdoorsEKONKey= 'https://api.mapbox.com/v4/mapbox.outdoors/%.2f,%.2f,%.2f,0/%dx%d.png128?access_token=pk.eyJ1IjoibWF4Ym94IiwiYSI6ImNpdHkxeXplaDAwMzkyenAxcXBhdXNpcmcifQ.Zr-dpQ8uLP7TKLcVwyq_zg';
 
// $ curl -g "https://api.mapbox.com/styles/v1/mapbox/streets-v12/static/-122.4241,37.78,15.25,0,60/400x400?access_token=YOUR_MAPBOX_ACCESS_TOKEN" --output example-mapbox-static-1.png

{# Retrieve a map at -122.4241 longitude, 37.78 latitude,
# zoom 15.25, bearing 0, and pitch 60. The map
# will be 400 pixels wide and 400 pixels high
# and save the output as a PNG image.
$ curl -g "https://api.mapbox.com/styles/v1/mapbox/streets-v12/static/-122.4241,37.78,15.25,0,60/400x400?access_token=YOUR_MAPBOX_ACCESS_TOKEN" --output example-mapbox-static-1.png

# Retrieve a map at 0 longitude, 10 latitude, zoom 3,
# and bearing 20. Pitch will default to 0
# and save the output as a PNG image.
$ curl -g "https://api.mapbox.com/styles/v1/mapbox/streets-v12/static/0,10,3,20/600x600?access_token=YOUR_MAPBOX_ACCESS_TOKEN" --output example-mapbox-static-2.png}
  
   mapboxAPIMapOutdoorsEKONKey= 'https://api.mapbox.com/styles/v1/mapbox/streets-v12/static/%.3f,%.2f,%.2f,0,60/%dx%d?access_token=pk.eyJ1IjoibWF4Ym94IiwiYSI6ImNpdHkxeXplaDAwMzkyenAxcXBhdXNpcmcifQ.Zr-dpQ8uLP7TKLcVwyq_zg';

var //#tech:6.202perf: 0:0:8.205 threads: 19 192.168.56.1 23:18:19 4.7.6.500
  //TForm1 = class(TForm)
    Robo: TShape;
    ResetBtn: TButton;
    StartBtn: TButton;
       procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: Integer);
       procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
         Y: Integer);
       procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: Integer);
       procedure FormActivate(Sender: TObject);
       procedure ResetBtnClick(Sender: TObject);
       procedure StartBtnClick(Sender: TObject);
       procedure FormPaint(Sender: TObject);
  //private
    { Private declarations }
  //public { Public declarations }
    var Drawing:boolean;
    StartPoint:TPoint;
    saved:array of TPoint;
    count:integer;
    freq:int64;  //end;
    abitmap: TBitmap;
    MAPPATH2: string;


var
  Form1: TForm;

implementation

//{$R *.DFM}
//{Uses mmsystem, {to get to queryperformance functions}
  //   math; {to get to max function}
  
  
function GetGeoInfoMap4save(const lat,lon, zoom: double; asize: integer;
                               const UrlGeoLookupInfo, apath: string): string;
  var
    pngStream: TMemoryStream;
  begin
    pngStream:= TMemoryStream.Create;
      try
      HttpGet(Format(UrlGeoLookupInfo,[lon,lat,zoom, asize,asize]), pngStream);
        //WinInet Circuit
        writeln('size '+itoa(pngstream.size));
        writeln(streamtostring3(pngstream));
      except
        //lHTTP.Get1(Format(UrlGeoLookupInfo2,[IpAddress]), lStream);
        //if something wrong try using backup server.
        writeln(ExceptionToString(ExceptionType, ExceptionParam));
      end;
  with TLinearBitmap.Create do try
    pngStream.Position:= 0;
    LoadFromStream2(pngStream,'PNG');
    //paintToCanvas(form1.canvas, 
      //                     Rect(25,25,Width,Height),false);
    //savetobitmap                       
    SaveToFile(apath);
    //assignto(abitmap);
  finally
    Dispose;
    Free;
    pngStream.Free;
  end;
end;    


procedure FormActivate(Sender: TObject);
{Called when the form is activated - do initialization stuff}
begin
  drawing:=false;
  setlength(saved,maxpoints); {initialize saved array size}
  count:=0;  {set saved point count to 0}
  form1.doublebuffered:=true; {prevent ficker}
  resetbtnclick(sender);
  //form1.canvas.brush.bitmap:= 
  //getbitmap('C:\maXbox\EKON20\EKON20_Scripts\examples\roboline_outdoor_layer.bmp')
    {Get timer counts/sec for use in cointrolling speed later}
  queryperformancefrequency(freq);
  freq:=freq div 1000; {convert it to counts per ms}
end;

procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
 {Called when user presses the mouse}
begin
  Drawing:=true;
  {Set up for drawing}
  form1.canvas.moveto(x,y);
  form1.canvas.pen.width:= 9;
  form1.canvas.pen.color:=clBlue;
  {increment counter and save the starting point}
  inc(count);
  saved[count]:=point(x,y);
  application.processmessages;
end;

procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
{User moved mouse}
begin
  If drawing then begin
    form1.canvas.lineto(x,y);
    sleep(sleepms);
    inc(count);
    if count>length(saved) then setlength(saved,length(saved)+maxpoints);
    saved[count]:=point(x,y);
    application.processmessages;
  end;
  application.processmessages;
  
end;

procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{User released the button}
begin
  Drawing:=false;
  Robo.left:=saved[1].x-robo.Width div 2;
  Robo.top:=saved[1].y-Robo.Height div 2;
end;

procedure ResetBtnClick(Sender: TObject);
{Called to reset the track}
begin
  if count>0 then begin{erase the track}
    form1.canvas.pen.color:= form1.color; {Set brush to form color}
    form1.invalidate; {This forces form to be repainted - only it will be erasing}
    count:=0;
  end;
  {Move the robot back out of the drawing area}
  Robo.left:=8 * form1.width div 10;  {90% across}
  Robo.top:= form1.height div 4;    {1/4 from the top}
end;

procedure StartBtnClick(Sender: TObject);
{User clicked start}
var  i:integer;
  drawtime:integer;
  startcount,stopcount:int64;
begin
  for i:= 2 to count do begin
    {put center of robo on the point}
    Robo.left:=saved[i].x-Robo.width div 2;
    Robo.top:=saved[i].y-Robo.height div 2;
    queryperformanceCounter(startcount);{Get time before we repaint}
    application.processmessages;
    queryPerformanceCounter(stopcount);{Get time after repaint}
    drawtime:=(stopcount-startcount) div freq;  {Compute ms to repaint}
    writeln('test freq ms: '+itoa(drawtime))
    sleep(max(0,sleepms-drawtime));   {wait whatever time is left, if any}
  end;
end;

procedure FormPaint(Sender: TObject);
{Called eveytime anything visual changes on the form}
var i:integer;
begin
  {Redraw the track which got erased when windows erased everything to repaint}
  //application.processmessages;
  If count>0 then begin
    form1.canvas.moveto(saved[1].x,saved[1].y);
    for i:=1 to count do form1.canvas.lineto(saved[i].x,saved[i].y);
  end;
  if not drawing then
    form1.canvas.draw(0,0,abitmap);       // }
end;

procedure TForm1_FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //runflag:=false;
  //inFrm.Release;
  action:=cafree;
  abitmap.Free;
  writeln('GIS Map Moon Form closed... ');
end;

procedure loadRoboform;
begin
  Form1:= TForm.create(self)
   Robo:= TShape.create(self)   //cause of resewt in formactivate
   with form1 do begin
     SetBounds(69,73,840,840)
     Caption:= 'mX4: Click & drag draw path, Start to make Robo learn'
     Color := clBlack; //clBtnFace
     Font.Charset := DEFAULT_CHARSET
     Show;
     //OnActivate := @FormActivate
     FormActivate(self)
     OnMouseDown := @FormMouseDown
     OnMouseMove := @FormMouseMove
     OnMouseUp := @FormMouseUp
     OnPaint := @FormPaint;
     onClose:= @TForm1_FormClose;
     PixelsPerInch := 96
     //TextHeight(16)
    end; 
    //FormActivate(self)
    abitmap:= getbitmap(MAPPATH);
    with robo do begin
       parent:= form1
       setbounds(600,228,50,50)
       Brush.Color := clRed
       Shape:= stCircle 
       Brush.Style:= bsCross;
     end;
     with TBitBtn.create(self) do begin
       parent:= form1          
       setBounds(645,30,120,50)
       glyph.LoadFromRes(HINSTANCE,'TAFTERMINAL'); // CL_MPSTOP');
       font.size:= 11
       Caption := 'Start Robo'
       OnClick := @StartBtnClick
     end;
    with TBitBtn.create(self) do begin
       parent:= form1          
       setBounds(645,90,120,50)
       glyph.LoadFromRes(HINSTANCE,'TASBARCODE'); 
       font.size:= 11
       Caption := 'Reset Robo'
       OnClick := @ResetBtnClick
     end;
  end;


Begin //main
  //ProcessMessagesOFF;
    //GetGeoInfoMap4save(48.58,7.74,17,850,mapboxAPIMapOutdoorsEKONKey,
    ProcessMessagesOFF;
    if Not DirectoryExists(ExePath+'examples') then
                                createDir(exepath+'examples');
    if IsInternet then
      GetGeoInfoMap4save(51.22,6.77,16,850,mapboxAPIMapOutdoorsEKONKey,
                ExePath+'examples\667_roboline_outdoor_layer5.bmp');
  
    loadRoboform;
    
  //ProcessMessagesOFF;
  
End.

//http://www.themoviespoiler.com/Spoilers/Gravity.html

{const
  MAXX = 40 ;
type
  ImgObj = record
    Addrs : string;
    X: Integer ;
    Y: Integer ;
  end;
var
  All : array[1..MAXX] of ImgObj ;

procedure TForm1.btn1Click(Sender: TObject);
var
  BuffBitmap :TBitmap ;
  I,j,k: Integer;
begin
  // set  all bit maps
  ....
  // draw 40 images
  BuffBitmap := TBitmap.Create ;
  for I := 1 to MAXX do
  begin
    BuffBitmap.LoadFromFile(All[i].Addrs);
    for j := 0 to BuffBitmap.Width-1 do
      for k := 0 to BuffBitmap.Height-1 do
      begin
        Self.Canvas.Pixels[All[i].X+j,All[i].Y+k] := BuffBitmap.Canvas.Pixels[j,k] ;
      end;
  end;

  BuffBitmap.free;
end;}