unit U_ConvertTest_Astronomy;
{ Copyright   01-03, Gary Darby,  www.DelphiForFun.org

 This program may be used or modified for any non-commercial purpose
 so long as this original notice remains in place.
 All other rights are reserved #locs:1015
 }
 
 //#sign:Max: MAXBOX10: 13/09/2019 12:18:03 


interface

{uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, U_Astronomy, Buttons, shellapi;
 }
 
type

  T3DVector=record
    x,y,z:extended;
  end;

  TTConvertTest = TForm;
  var
    DatePicker: TDateTimePicker;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    TZBox: TComboBox;
    Label8: TLabel;
    NSRGrp: TRadioGroup;
    EWRGrp: TRadioGroup;
    LatEdt: TEdit;
    LongEdt: TEdit;
    DLSRGrp: TRadioGroup;
    BitBtn1: TBitBtn;
    GroupBox1: TGroupBox;
    TimeInRGrp: TRadioGroup;
    Label6: TLabel;
    CoordInRGrp: TRadioGroup;
    HrDegInLbl: TLabel;
    XInEdt: TEdit;
    Label9: TLabel;
    YInEdt: TEdit;
    GroupBox2: TGroupBox;
    Label14: TLabel;
    HrDegOutLbl: TLabel;
    Label16: TLabel;
    TimeOutRGrp: TRadioGroup;
    TimeOut: TDateTimePicker;
    CoordOutRGrp: TRadioGroup;
    XoutEdt: TEdit;
    YOutEdt: TEdit;
    Panel1: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    SRAz: TEdit;
    SSAz: TEdit;
    SRmsg: TEdit;
    aSSTime: TEdit;
    SRTime: TEdit;
    TimeIn: TDateTimePicker;
    StaticText1: TStaticText;
    Label7: TLabel;
    aMemo1: TMemo;
    {procedure FormActivate(Sender: TObject);}
       procedure TTConvertTestTestBtnClick(Sender: TObject);
       procedure TTConvertTestDatePickerUserInput(Sender: TObject;
         const UserString: String; var DateAndTime: TDateTime;
         var AllowChange: Boolean);
       procedure TTConvertTestDLSRGrpClick(Sender: TObject);
       procedure TTConvertTestCoordInRGrpClick(Sender: TObject);
       procedure TTConvertTestFormClose(Sender: TObject; var Action: TCloseAction);
       procedure TTConvertTestCoordOutRGrpClick(Sender: TObject);
       procedure TTConvertTestStaticText1Click(Sender: TObject);
     //private
    { Private declarations }
  //public
    { Public declarations }
   var 
   astro:TAstronomy;
    sunrise:single; { Sunrise time                 }
    sunset:single; { Sunset time                  }
    sunriseangle, sunsetangle:extended;
    function GetBaseData:boolean;
 //end;


var
  TConvertTest: TTConvertTest;

implementation

//{$R *.DFM}
//Uses math;

var
  deg:char;  //=char(176);


function cosd(t:extended):extended;
  begin  result:= cos(0.01745329251994 * t); end;

function sind(t:extended):extended;
  begin  result:= sin(0.01745329251994 * t); end;

function tand(t:extended):extended;
  var
    x:extended;
  begin
    x:=degtorad(t);
    result:= tan(x);
  end;


function JulianDay(d:TDateTime):integer;
var
  y,m,day:word;
begin
  decodedate(d,y,m,day);
  result:=trunc(d-encodedate(y-1,12,31));
end;


 procedure setmessage(s:string; aresult: boolean);
  begin
    showmessage(s);
    aresult:=false;
  end;

{********************** GetBaseData ***************}
function GetBaseData:boolean;
  
var
  p:TRpoint;
  y,m,day:word;
begin
  //astro:= TAstronomy.create;    --> main
  deg:= chr(176);
  with astro do begin
    result:=true;
    //datepicker.datetime:= Now;
    decodedate(datepicker.datetime,y,m,day);
 
    Adate:= encodedate(y,m,day);  //(datepicker.date);
    //Adate:= datepicker.date;
    writeln(datetostr(adate))
    if tzbox.itemindex>0 then tzhours:=tzbox.itemindex-12
    else setmessage('Select a time zone from list',result);
    if strtoangle(longedt.text,p.x) then begin
      p.x:=abs(p.x);
      if EWRGrp.itemindex>0 then p.x:=-p.x;
    end
    else setmessage('Invalid longitude, must be 1 to 3 numbers separated by spaces',result);
    if strtoangle(latedt.text,p.y) then
    begin
      p.y:=abs(p.y);
      if NSRGrp.itemindex>0 then p.y:=-p.y;
    end
    else setmessage('Invalid latitude, must be 1 to 3 numbers separated by spaces',result);
    dlshours:=DLSRGrp.itemindex;
    lonlat:=p;
  end;
end;

procedure TTConvertTestTestBtnClick(Sender: TObject);
{test Tastronomy class}
var
  inval,outval:TRPoint;
  srise,sset, LSTUp, LSTDown:extended;
  savetime:TDateTime;
begin
  if getbasedata then
  with astro do begin
    case TimeInRGrp.itemindex of
      0: {Local} localtime:=timeIn.time;
      1: {UT} Universaltime:=timeIn.time;
      2: {Greenwich Sidereal} GSTime:=timeIn.time;
      3: {Local Sidereal} LSTime:=timeIn.time;
    end;

    case TimeOutRGrp.itemindex of
      0: {Local} timeout.time:=localtime;
      1: {UT} timeout.time:=Universaltime;
      2: {Greenwich Sidereal} timeout.time:=GSTime;
      3: {Local Sidereal} timeout.time:=LSTime;
    end;
    If (CoordInRGrp.itemindex>=0) then begin
      strtoangle(XInEdt.text, inval.x);
      strtoangle(YInEdt.text,inval.y);
      case CoordInRGrp.itemindex of
       0: AzAlt:=inval;
       1: EcLonLat:=inval;
       2: HaDecl:=inval;
       3: RADecl:=Inval;
       4: GalLonLat:=inval;

      end;
      with coordOutRgrp do
      If (itemindex>=0) then begin
        case ItemIndex of
          0: outval:=AzAlt;
          1: Outval:=EcLonLat;
          2: outval:=HaDecl;
          3: Outval:=RADecl;
          4: OutVal:=GalLonLat;
        end;
        if (itemindex=2) or (itemindex=3)
        then begin
         XOutEdt.text:=formatdatetime('hh:mm:ss.z',Outval.x/24.0);
         HrDegOutLbl.caption:='X (H:M:S)';
        end
        else begin
          XOutEdt.text:=angletostr(Outval.x);
          HrDegOutLbl.caption:='X (D,M,S)';
        end;
        YOutEdt.text:=angletostr(Outval.y);
      end;

      (*
      SrMsg.text:=riseset(rpoint(RADecl.x*15,radecl.y),
                 0,srise, sset, LSTup,LSTDown);
      If srmsg.text='' then
      begin
        sunriseangle:=srise;
        sunsetangle:=sset;
        SRAz.text:=angletostr(sunriseangle);
        SSAz.text:=angletostr(sunsetangle);
        savetime:=localtime;
        //convertLSTime(UpTmaz.x/24.0,GS,sunrise,UT);
        //convertLSTime(DnTmaz.x/24.0,GS,sunset,UT);
        LSTime:=LstUp/24;
        SRTime.text:=Timetostr(localtime);
        LSTime:=LstDown/24;
        SSTime.text:=Timetostr(localtime);
        localtime:=savetime;
      end
      else
      begin
        SRAz.text:='0:0:0';
        SSAZ.text:='0:0:0';;
        SrTime.text:='0:0:0';
        SSTime.text:='0:0:0';
      end;
      *)
    end;
  end; {with astro}
 end;

procedure TTConvertTestDatePickerUserInput(Sender: TObject;
  const UserString: String; var DateAndTime: TDateTime;
  var AllowChange: Boolean);
begin
  try
    DateAndTime:=strtodate(userstring);
  except
  end;
end;

procedure TTConvertTestDLSRGrpClick(Sender: TObject);
begin
  astro.DLSHours:=DLSRGrp.itemindex+1;
end;

procedure TTConvertTestCoordInRGrpClick(Sender: TObject);
var
  LSTUp, LSTDown:TDatetime;
  uptmaz, dntmaz:TRPoint;
  GS,UT:TDateTime;
  sunrec:TSunrec;
  errmsg:string;

begin
  with astro,CoordInRGrp do
  if getbasedata then begin
    HrDegInLbl.caption:='X (D,M,S)';
    case itemindex of
    2,3: HrDegInLbl.caption:='X (H:M:S)';
    5: begin    //position for thos time
         //SunPos(Sunrec);   bugfix
         Xinedt.Text:=angletostr(Sunrec.TrueAzAlt.x);
         YInedt.text:=angletostr(Sunrec.TrueAzAlt.y);
         CoordinRGrp.itemindex:=0;
       end;
    6: {sunrise}
       with astro do begin
         errmsg:=Sunriseset(0,UpTMAz,DNTmAz);
         xInedt.text:=angletostr(uptmaz.y);
         yInedt.text:=angletostr(-0.833333);{- 5/6 degree=alt of sun center at sunrise}
         convertLSTime(UpTmaz.x/24.0,GS,LSTUp,UT);
         localtime:=LSTUp;
         timein.time:=localtime;
         timeinrgrp.itemindex:=0;
         itemindex:=0;
       end;
     7: {sunset}
       with astro do begin
         errmsg:=Sunriseset(0,UpTMAz,DNTmAz);
         xInedt.text:=angletostr(Dntmaz.y);
         yInedt.text:=angletostr(-0.833333);{- 5/6 degree=alt of sun center at sunset}
         convertLSTime(DnTmaz.x/24.0,GS,LSTDown,UT);
         localtime:=LSTDown;
         timein.time:=localtime;
         timeinrgrp.itemindex:=0;
         itemindex:=0;
       end;
    end;
  end;
end;

procedure TTConvertTestCoordOutRGrpClick(Sender: TObject);
{user changed output coordinate system}
begin
  with CoordOutRGrp
  do
   if (itemindex =2) or (itemindex=3)
   then HrDegOutLbl.caption:='X (H:M:S)'
   else HrDegOutLbl.caption:='X (D,M,S)';
   TTConvertTesttestbtnclick(sender);  {recalculate data}
end;

procedure TTConvertTestFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  TConvertTest.modalresult:=MrOK;
  astro.Free;
  astro:= NIL
  writeln('Astro free and Close..')
end;

function StripHTML(S: string): string;
var
  TagBegin, TagEnd, TagLength: integer;
begin
  TagBegin := Pos( '<', S);      // search position of first < 
  while (TagBegin > 0) do begin  // while there is a < in S
    TagEnd := Pos('>', S);              // find the matching > 
    TagLength := TagEnd - TagBegin + 1;
    Delete(S, TagBegin, TagLength);     // delete the tag 
    TagBegin:= Pos( '<', S);            // search for next <
  end;
  
  Result := S;                   // give the result
end;

procedure TForm1TDatetimeButton1Click(Sender: TObject);
var
  File_Name: string;
  DateTimeStamp: integer;
  Date_Time: TDateTime;
begin
  File_Name := 'c:\mydocuments\test.doc';
  DateTimeStamp := FileAge(File_Name);
  // FileAge returns -1 if file not found
  if DateTimeStamp < 0 then
    ShowMessage('File not found')
  else begin
    // Convert to TDateTime format
    Date_Time := FileDateToDateTime(DateTimeStamp);
    Label1.Caption := DateToStr(Date_Time);
    Label2.Caption := TimeToStr(Date_Time);
  end;
end;

procedure TForm1Button1ClickShow(Sender: TObject);
begin
  ShowWindow(Application.Handle, SW_HIDE);
end;

procedure TForm1SetLabelsFontColor(NewColor: TColor);
var
  i: Integer;
begin
  for i := 0 to self.ComponentCount - 1 do
    if self.Components[i] is TLabel then
      TLabel(self.Components[i]).Font.Color := NewColor;
end;

function RoundCorrect(R: Real): LongInt;
begin
  Result:= Trunc(R);       // extract the integer part 
  if Frac(R) >= 0.5 then   // if fractional part >= 0.5 then...
    Result:= Result + 1;   // ...add 1
end;


procedure TTConvertTestStaticText1Click(Sender: TObject);
begin
  //ShellExecute(Handle, 'open', 'http://www.delphiforfun.org/',
  //nil, nil, SW_SHOWNORMAL);
end;

 var atex: boolean;
 
 
 procedure loadconvertTestform;
 begin
 TConvertTest:= TTConvertTest.create(self)
 with TConvertTest do begin
  Left := 156
  Top := 37
  Width := 779
  Height := 600
  Caption := 'TAstronomy maXbox4 Conversion Tests Bern'
  Color := clBtnFace
  Font.Charset := DEFAULT_CHARSET
  Font.Color := clWindowText
  Font.Height := -11
  Font.Name := 'MS Sans Serif'
  Font.Style := [fsBold]
  OldCreateOrder := False
  Position := poScreenCenter
  formstyle:= fsstayontop;
  Scaled := False
  OnClose := @TTConverttestFormClose
  PixelsPerInch := 96
  //TextHeight := 13
  Show;
  end;
  Label1:= TLabel.create(self)
  with label1 do begin
    parent:= tconverttest;
    Left := 16
    Top := 84
    Width := 94
    Height := 13
    Caption := 'Latitude (D M S)'
  end;
  //object Label2: TLabel
  Label2:= TLabel.create(self)
  with label2 do begin
    parent:= tconverttest;
    Left := 16
    Top := 36
    Width := 104
    Height := 13
    Caption := 'Longitude (D M S)'
  end;
  //object Label3: TLabel
  Label3:= TLabel.create(self)
  with label3 do begin
    parent:= tconverttest;  
    Left := 360
    Top := 24
    Width := 28
    Height := 13
    Caption := 'Date'
  end;
//  object Label8: TLabel
  Label8:= TLabel.create(self)
  with label8 do begin
    parent:= tconverttest;
    Left := 360
    Top := 80
    Width := 61
    Height := 13
    Caption := 'Time Zone'
  end;
  DatePicker:= TDateTimePicker.create(self)
  with datepicker do begin
   parent:= tconverttest;
    Left := 416
    Top := 20
    Width := 97
    Height := 21
    CalAlignment := dtaLeft
    Datetime := Now; //33870
    Time := Now; //33870
    DateFormat := dfShort
    DateMode := dmComboBox
    Kind := dtkDate
    ParseInput := True
    TabOrder := 0
    OnUserInput := @ttconverttestDatePickerUserInput
  end;
  TZBox:= TComboBox.create(self)
  with tzbox do begin
    parent:= tconverttest;
    Left := 432
    Top := 76
    Width := 81
    Height := 21
    Style := csDropDownList;
    ItemHeight := 13
    TabOrder := 1
    with items do begin
       add('-12')
       add('-11')
       add('-10')
       add('-09')
      add('-08  (PST)')
      add('-07  (MST)')
      add('-06  (CST)')
      add('-05  (EST)')
      add('-04  ')
      add('-03 ')
      add('-02 ')
      add('-01')
      add('00')
      add('+01')
      add('+02')
      add('+03')
      add('+04')
      add('+05')
      add('+06')
      add('+07')
      add('+08')
      add('+09')
      add('+10')
      add('+11')
     end; 
    itemindex:= 14;
  end;
  NSRGrp:= TRadioGroup.create(self)
  with nsrgrp do begin
   parent:= tconverttest;
    Left := 256
    Top := 62
    Width := 81
    Height := 49
    ItemIndex := 1
    Items.add('North')
    items.add('South')
    TabOrder := 2
  end;
  EWRGrp:= TRadioGroup.create(self)
  with ewrgrp do begin
    parent:= tconverttest;
    Left := 256
    Top := 14
    Width := 81
    Height := 49
    ItemIndex := 0
    Items.add ('East')
    items.add('West')
    TabOrder := 3
  end;
  LatEdt:= TEdit.create(self)
  with latedt do begin
    parent:= tconverttest;
    Left := 136
    Top := 80
    Width := 97
    Height := 21
    TabOrder := 4
    Text := '46 57 0.12'; //'46 55 0.12'; //'20 0 3.4'
    //Lat/Long: 4657'N / 727'E
  end;
  LongEdt:= TEdit.create(self)
  with longedt do begin
    parent:= tconverttest;
    Left := 136
    Top := 32
    Width := 97
    Height := 21
    TabOrder := 5
    Text := '7 27 0.12'; //'7 28 0.12';   //      '62 10 12'   //46.9167, 7.4667)
  end;
  DLSRGrp:= TRadioGroup.create(self)
  with dlsrgrp do begin
   parent:= tconverttest;
    Left := 552
    Top := 24
    Width := 177
    Height := 73
    Caption := 'Daylight Saving'
    ItemIndex := 0
   // Items.Strings := (
    Items.add('Added 0 hours to local')
      items.add('Added 1 hour to local')
      items.add('Added 2 hours to local')
    TabOrder := 6
    OnClick := @TTconverttestDLSRGrpClick
  end;
  BitBtn1:= TBitBtn.create(self)
  with bitbtn1 do begin
    parent:= tconverttest;
    Left := 296
    Top := 184
    Width := 188
    Height := 45
    Caption := 'Convert In to Out'
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clWindowText
    Font.Height := -14
    Font.Name := 'MS Sans Serif'
    Font.Style := [fsBold]
    ParentFont := False
    TabOrder := 7
    OnClick := @ttconverttestTestBtnClick
    glyph.LoadFromRes(getHINSTANCE,'TZSQLProcessor');
    (*Glyph.Data := {
      76010000424D7601000000000000760000002800000020000000100000000100
      04000000000000010000120B0000120B00001000000000000000000000000000
      800000800000008080008000000080008000808000007F7F7F00BFBFBF000000
      FF0000FF000000FFFF00FF000000FF00FF00FFFF0000FFFFFF00333333333333
      3333333333333333333333333333333333333333333333333333333333333333
      3333333333333333333333333333333333333333333FF3333333333333003333
      3333333333773FF3333333333309003333333333337F773FF333333333099900
      33333FFFFF7F33773FF30000000999990033777777733333773F099999999999
      99007FFFFFFF33333F7700000009999900337777777F333F7733333333099900
      33333333337F3F77333333333309003333333333337F77333333333333003333
      3333333333773333333333333333333333333333333333333333333333333333
      3333333333333333333333333333333333333333333333333333} *)
    Layout := blGlyphRight
    NumGlyphs := 1
  end;
  GroupBox1:= TGroupBox.create(self)
  with groupbox1 do begin
   parent:= tconverttest;
    Left := 8
    Top := 120
    Width := 257
    Height := 409
    Caption := 'Data In'
    TabOrder := 8
    end;
    Label6:= TLabel.create(self)
    with label6 do begin
    parent:= groupbox1
      Left := 24
      Top := 124
      Width := 75
      Height := 13
      Caption := 'Time (H,M,S)'
    end;
    HrDegInLbl:= TLabel.create(self)
    with hrdeginlbl do begin
     parent:= groupbox1
      Left := 32
      Top := 340
      Width := 60
      Height := 13
      Caption := 'X  (D,M,S)'
    end ;
    Label9:= TLabel.create(self)
    with label9 do begin
     parent:= groupbox1 
      Left := 32
      Top := 372
      Width := 60
      Height := 13
      Caption := 'Y  (D,M,S)'
    end;
    TimeInRGrp:= TRadioGroup.create(self)
    with timeinrgrp do begin
     parent:= groupbox1
      Left := 24
      Top := 24
      Width := 185
      Height := 89
      Caption := 'Time base '
      ItemIndex := 0
      Items.add ('Local ')
        items.add('Universal ')
        items.add('Greewich sidereal')
        items.add('Local sidereal')
      TabOrder := 0
    end;
    CoordInRGrp:= TRadioGroup.create(self)
    with coordinrgrp do begin
     parent:= groupbox1
      Left := 24
      Top := 152
      Width := 185
      Height := 169
      Caption := 'Coordinate system'
      ItemIndex := 2
      Items.add ('Horizon (Azimuth,Altitude)')
      Items.add ( 'Ecliptic (Long,Lat)')
      Items.add ( 'Equatorial (HA,Decl)')
      Items.add ( 'Equatorial (RA,Decl)')
      Items.add ( 'Galactic (Long,Lat)')
      Items.add ( 'Sun Position for this time')
      Items.add ( 'Sunrise')
      Items.add ( 'Sunset')
      TabOrder := 1;
      OnClick :=@ttconverttestCoordInRGrpClick
    end;
    XInEdt:= TEdit.create(self)
    with xinedt do begin
     parent:= groupbox1
      Left := 104
      Top := 336
      Width := 105
      Height := 21
      TabOrder := 2
      Text := '12 16 0'
    end;
    YInEdt:= TEdit.create(self)
    with yinedt do begin
     parent:= groupbox1
      Left := 104
      Top := 368
      Width := 105
      Height := 21
      TabOrder := 3
      Text := '14 34 0'
    end;
    TimeIn:= TDateTimePicker.create(self)
    with timein do begin
     parent:= groupbox1
      Left := 104
      Top := 120
      Width := 105
      Height := 21
      CalAlignment := dtaLeft
      Datetime := Now; //36526.9391921296
      Time := Now; //36526.9391921296
      DateFormat := dfShort
      DateMode := dmComboBox
      Kind := dtkTime
      ParseInput := False
      TabOrder := 4
    end;
  //end
  GroupBox2:= TGroupBox.create(self)
  with groupbox2 do begin
   parent:= tconverttest;
    Left := 496
    Top := 136
    Width := 257
    Height := 393
    Caption := 'Data Out'
    TabOrder := 9
    end;
    Label4:= TLabel.create(self)
    with label4 do begin
     parent:= groupbox2
      Left := 24
      Top := 124
      Width := 75
      Height := 13
      Caption := 'Time (H,M,S)'
    end;
    HrDegOutLbl:= TLabel.create(self)
    with hrdegoutlbl do begin
     parent:= groupbox2
      Left := 32
      Top := 300
      Width := 60
      Height := 13
      Caption := 'X  (D,M,S)'
    end;
    Label16:= TLabel.create(self)
    with label16 do begin
     parent:= groupbox2
      Left := 32
      Top := 332
      Width := 60
      Height := 13
      Caption := 'Y  (D,M,S)'
    end;
    TimeOutRGrp:= TRadioGroup.create(self)
    with timeoutrgrp do begin
     parent:= groupbox2
      Left := 24
      Top := 24
      Width := 200
      Height := 89
      Caption := 'Time base'
      ItemIndex := 1
      Items.add('Local ')
        items.add('Universal ')
        items.add('Greenwich sidereal')
        items.add('Local sidereal');
      TabOrder := 0
      OnClick := @ttconverttestTestBtnClick
    end ;
    TimeOut:= TDateTimePicker.create(self)
    with timeout do begin
      parent:= groupbox2
      Left := 104
      Top := 120
      Width := 105
      Height := 21
      CalAlignment := dtaLeft
      Datetime := 36526.9391921296
      Time := 36526.9391921296
      DateFormat := dfShort
      DateMode := dmComboBox
      Kind := dtkTime
      ParseInput := False
      TabOrder := 1
    end;
    CoordOutRGrp:= TRadioGroup.create(self)
    with coordoutrgrp do begin
     parent:= groupbox2
      Left := 24
      Top := 160
      Width := 200
      Height := 121
      Caption := 'Coordinate system'
      ItemIndex := 0
   //   Items.Strings := (
      Items.add ('Horizon (Azimuth,Altitude)')
      Items.add ( 'Ecliptic (Long,Lat)')
      Items.add ( 'Equatorial (HA,Decl)')
      Items.add ( 'Equatorial (RA,Decl)')
      Items.add ( 'Galactic (Long,Lat)')
      TabOrder := 2
      OnClick := @ttconverttestCoordOutRGrpClick
    end;
    XoutEdt:= TEdit.create(self)
    with xoutedt do begin
     parent:= groupbox2
      Left := 120
      Top := 296
      Width := 105
      Height := 21
      TabOrder := 3
      Text := '12 16 0'
    end;
    YOutEdt:= TEdit.create(self)
    with youtedt do begin
     parent:= groupbox2
      Left := 120
      Top := 328
      Width := 105
      Height := 21
      TabOrder := 4
      Text := '14 34 0'
    end;
  //end
  Panel1:= TPanel.create(self)
  with panel1 do begin
   parent:=  tconverttest;
    Left := 288
    Top := 304
    Width := 185
    Height := 225
    TabOrder := 10
    Visible := false
    end;
    Label4:= TLabel.create(self)
    with label4 do begin
     parent:= panel1
      Left := 48
      Top := 32
      Width := 47
      Height := 13
      Caption := 'Sunrise jjj'
    end;
    Label5:= TLabel.create(self)
    with label5 do begin
     parent:= panel1
      Left := 37
      Top := 63
      Width := 57
      Height := 13
      Caption := '   Azimuth'
    end;
    label10:= TLabel.create(self)
    with label10 do begin
     parent:= panel1
      Left := 51
      Top := 93
      Width := 44
      Height := 13
      Caption := 'Sunset '
    end;
    Label11:= TLabel.create(self)
    with label11 do begin
     parent:= panel1
      Left := 37
      Top := 124
      Width := 57
      Height := 13
      Caption := '   Azimuth'
    end;
    Label7:= TLabel.create(self)
    with label7 do begin
     parent:= panel1
      Left := 16
      Top := 152
      Width := 151
      Height := 13
      Caption := 'LST := Local Sideeal Time)'
    end;
    SRAz:= TEdit.create(self)
    with sraz do begin
     parent:= panel1
      Left := 104
      Top := 59
      Width := 73
      Height := 21
      ReadOnly := True
      TabOrder := 0
      Text := '0:0:0'
    end;
    SSAz:= TEdit.create(self)
    with ssaz  do begin
     parent:= panel1;
      Left := 104
      Top := 120
      Width := 73
      Height := 21
      ReadOnly := True
      TabOrder := 1
      Text := '0:0:0'
    end;
    //object SRmsg: TEdit
     Srmsg:= TEdit.create(self)
    with srmsg  do begin
     parent:= panel1;
      Left := 16
      Top := 176
      Width := 153
      Height := 21
      ReadOnly := True
      TabOrder := 2
    end;
    aSStime:= TEdit.create(self)
    with asstime  do begin
     parent:= panel1;
      Left := 104
      Top := 91
      Width := 73
      Height := 21
      ReadOnly := True
      TabOrder := 3
      Text := '0:0:0'
    end;
   // object SRTime: TEdit
     Srtime:= TEdit.create(self)
    with srtime  do begin
     parent:= panel1;
      Left := 104
      Top := 27
      Width := 73
      Height := 21
      ReadOnly := True
      TabOrder := 4
      Text := '0:0:0'
    end;
  //end
  StaticText1:= TStaticText.create(self)
  with statictext1 do begin
   parent:= tconverttest;
    Left := 0
    Top := 542
    Width := 771
    Height := 20
    Cursor := crHandPoint
    Align := alBottom
    Alignment := taCenter
    Caption := 'Copyright   2003, Gary Darby,  maXbox4 www.DelphiForFun.org'
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clBlue
    Font.Height := -13
    Font.Name := 'MS Sans Serif'
    Font.Style := [fsUnderline]
    ParentFont := False
    TabOrder := 11
    OnClick := @ttconverttestStaticText1Click
  end;
  aMemo1:= TMemo.create(self)
  with amemo1 do begin
   parent:= tconverttest;
    setbounds(280, 272, 201, 257)
    Lines.add (
      'Initial values are copied from '+
      'Astronomy Demo main form.  Make '+
      'any changes desired, select the '+
      'output time and coordinate '+
      'systems desired and click the '+
      '"Convert" button to view '+
      'conversion results.'+ CRLF+CRLF+
      ' '                   +
      'If you select one of the bottom '+
      'three radio buttons from the box '+
      'at left (Sun Position, Sunrise, '+
      'Sunset), the Time Base is set to '+
      '"Local", the coordinates '+
      'option is set to to "Horizon" '+
      'and Azimuth and Altitude are '+
      'displayed.  For "Sunrise" and '+
      '"Sunset", the Time field  is also '+
      'changed to that time.')
    TabOrder := 12
  end; //end;
end;


begin   //@main

     astro:= TAstronomy.create;
     
     loadconvertTestform;
     
     datepicker.datetime:= Now;
     //datepicker.date:= Now;
     
    //city of bern switzerland
    writeln('DegToDmsStr lat: '+DegToDmsStr(46.9167,4))
    writeln('DegToDmsStr lon: '+DegToDmsStr(7.4667,4))
    
    //Lat/Long: 4657'N / 727'E
     
     //astro.Free;

  //Proc JvXPConvertToGray2( Bitmap : TBitmap)
   //JvXPConvertToGray2(Bitmap);
   //bitmap.Free;
   //LoadDFMFile2Strings(const AFile:string; AStrings:TStrings; var WasText:boolean):Int
  { srlist:= TStringlist.create;
   LoadDFMFile2Strings('C:\maXbox\maxbox3\maxbox3\maXbox3\examples\mX425010\U_ConvertTest.dfm', srlist,atex)
   writeln(srlist.text)
   srlist.free;  //}

End.



{DegToDmsStr lat: 46 55' 0.1200"
DegToDmsStr lon: 7 28' 0.1200"}
