unit FANN_XorSample;

interface

{uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FannNetwork, StdCtrls;    }
  
  //http://leenissen.dk/fann/wp/2015/11/fann-in-research/

type
  TForm1 = TForm; //)
  var
    btnTrain: TButton;
    LblError: TLabel;
    lblMSE: TLabel;
    btnRun: TButton;
    memoXor: TMemo;
    btnBuild: TBitBtn;
    NN: TFannNetwork;
    procedure TForm1btnTrainClick(Sender: TObject);
    procedure TForm1btnRunClick(Sender: TObject);
    procedure TForm1btnBuildClick(Sender: TObject);
  //private
    { Private declarations }
  //public
    { Public declarations }
  //end;

var
  Form1: TForm1;

implementation

//{$R *.dfm}

procedure TForm1btnTrainClick(Sender: TObject);
var inputs: array [0..1] of single;
    outputs: array [0..0] of single;
    //outputs: array of single;
    
    e,i,j: integer;
    mse: single;
begin


        //Train the network
        for e:=1 to 6000 do //Train 30000 epochs
        begin

                for i:=0 to 1 do
                begin
                        for j:=0 to 1 do
                        begin
                            inputs[0]:=i;
                            inputs[1]:=j;
                            outputs[0]:=i Xor j;

                            mse:=NN.Train(inputs,outputs);
                            lblMse.Caption:=Format('%.4f',[mse]);
                            Application.ProcessMessages;

                        end;
                end;
        end;

        
        ShowMessage('Network Training Ended...');

end;

procedure TForm1btnRunClick(Sender: TObject);
var i,j: integer;
    //aoutput: array [0..0] of single;
    inputs: array [0..1] of single;
   // aoutput: array of fann_type;
    //output: array of fann_type;
    //aoutput: Fann_Type_Array;
     aoutput: TFann_Type_Array3;
    
begin

     MemoXOR.Lines.Clear;
     
     setlength(aoutput, 4)
     //NN.Run(inputs,aoutput);
     //aoutput[0]:= 475.45

     for i:=0 to 1 do
     begin
        for j:=0 to 1 do
        begin
                inputs[0]:=i;
                inputs[1]:=j;
                NN.Run4(inputs,aoutput);
                MemoXor.Lines.Add(Format('%d XOR %d = %f',[i,j,aOutput[0]]));
        end;
     end;

     
end;

procedure TForm1btnBuildClick(Sender: TObject);
begin
        NN.Build;
        btnBuild.Enabled:=false;
        BtnTrain.Enabled:=true;
        btnRun.Enabled:=true;

end;

Procedure TestXML;
{uses
  Classes, XMLWrite, DOM; }
var
 // xdoc: TDomDocument;                      // variable objeto documento XML
  xdoc: TXMLDocumentDOM;                     // variable objeto documento XML
  XMLDoc: TXMLDocument;
  NodoRaiz, NodoPadre, NodoHijo: TDOMNode;             // variables a los nodos
  myStream :  TFileStream;
begin
  //crear el documento
 // xdoc := TDomDocument.create;
 //http://wiki.freepascal.org/TDOMDocument
  xdoc := TXMLDocumentDOM.create;
 
  NodoRaiz := xdoc.CreateElement('root');               // crear el nodo raz
  Xdoc.Appendchild(NodoRaiz);                           // guardar nodo raz
  NodoPadre := xdoc.CreateElement('element');           // crear el nodo hijo
  NodoHijo := xdoc.CreateTextNode('Some text here_4');    // insertar el valor del nodo
  NodoPadre.Appendchild(NodoHijo);                      // guardar nodo
  NodoRaiz.AppendChild(NodoPadre);                      // insertar el nodo hijo en el correspondiente nodo padre
 // writeXMLFile(xDoc,'prueba.xml');                      // escribir el XML
  //writeXMLFile(TXMLDocument(xDoc),exepath+'prueba.xml');   // escribir el XML
  //nodoraiz.text
  //DomToXMLParser
   writeln(xdoc.nodevalue)
   writeln(nodoraiz.nodevalue)
    WriteLn(NodoPadre.FirstChild.NodeValue);
 

   myStream := TFileStream.Create('treeview.xml',fmCreate);
 Try
   //{DomToXmlParser.}mystream.write(xdoc,myStream);
 Finally
   myStream.Free;
 End; 
  XMLDoc:= TXMLDocument.create2('');
  //XMLDoc.DOMDocument:= xdoc; Interface not supported at 17.645
  XMLDoc.Active := False;
  XMLDoc.XML.Text := '';
  XMLDoc.Active := True;
  //XMLDoc.SaveToFile('C:\Documents and Settings\a\Desktop\zulfa.xml');
  XMLDoc.Free;
  // writeXMLFile((xDoc as TXMLDocument),exepath+'prueba.xml');     // 
 
  //xdoc.savetofile
  Xdoc.free;
end;

procedure TForm1Button1Click(Sender: TObject);
var
  xdoc: TXMLDocumentDOM; // variable to document
  RootNode, parentNode, nofilho: TDOMNode; // variable to nodes
begin
  //create a document
  xdoc := TXMLDocumentDom.create;
 
  //create a root node
  RootNode := xdoc.CreateElement('register');
  Xdoc.Appendchild(RootNode); // save root node
 
  //create a parent node
  RootNode:= xdoc.DocumentElement;
  parentNode := xdoc.CreateElement('usuario');
  TDOMElement(parentNode).SetAttribute('id', '001'); // create atributes to parent node
  RootNode.Appendchild(parentNode); // save parent node
 
  //create a child node
  parentNode := xdoc.CreateElement('nome'); // create a child node
  //TDOMElement(parentNode).SetAttribute('sexo', 'M'); // create atributes
  nofilho := xdoc.CreateTextNode('Fernando'); // insert a value to node
  parentNode.Appendchild(nofilho); // save node
  RootNode.ChildNodes.Item[0].AppendChild(parentNode); // insert child node in respective parent node
 
  //create a child node
  parentNode := xdoc.CreateElement('idade'); // create a child node
  //TDOMElement(parentNode).SetAttribute('ano', '1976'); // create atributes
  nofilho := xdoc.CreateTextNode('32'); // insert a value to node
  parentNode.Appendchild(nofilho); // save node
  RootNode.ChildNodes.Item[0].AppendChild(parentNode); // insert a childnode in respective parent node
  //Function FormatXMLData( const XMLData : DOMString) : DOMString;
  //FormatXMLData(xdoc.text);
 
  //writeXMLFile2(xDoc,'teste.xml'); // write to XML
  Xdoc.free; // free memory
end;

procedure TForm1btnCreateXMLClick(Sender: TObject);
  var
   rootName:string;
  childName:string;
  attrChild:string;
   iXml: IDOMDocument;
   xmldoc: TXMLDocument;
  iRoot, iNode, iNode2, iChild, iAttribute, nofilho: IDOMNode;
begin
  XMLDoc:= TXMLDocument.create(nil);
  XMLDoc.Active:=false;
   XMLDoc.XML.Text:='';
   XMLDoc.Active:=true;
    XMLDoc.FileName:=exepath+'xmlDocument.xml';
    
     iXml := XmlDoc.DOMDocument;
     iXml.createElement ('xml');
     //iXml.appendChild(iXml.createElement ('xml'));
   //iRoot:=iXml.createElement(iXml.createElement('xml'));
   nofilho := ixml.CreateTextNode('Fernando');
   XmlDoc.DOMDocument:= ixml;
   writeln(FormatXMLData(XMLDoc.XML.Text));
    //iRoot := iXml.appendChild(iXml.createElement ('xml'));
    iRoot := iXml.appendChild(nofilho);
   
     // node "test"
     iNode := iRoot.appendChild (iXml.createElement ('test'));
      iNode.appendChild (iXml.createElement ('test2'));
   iChild := iNode.appendChild (iXml.createElement ('test3'));
    iChild.appendChild (iXml.createTextNode('simple value'));
     iNode.insertBefore (iXml.createElement ('test4'), iChild);

   // node replication
     iNode2 := iNode.cloneNode (True);
  iRoot.appendChild (iNode2);

    // add an attribute
      iAttribute := iXml.createAttribute ('color');
        iAttribute.setnodeValue ('red');
      //iNode2.attributes.setNamedItem (iAttribute);

    // show XML in memo
    //  memXMLOutput.Lines.Text:=FormatXMLData(XMLDoc.XML.Text);
      writeln(FormatXMLData(XMLDoc.XML.Text));
      XMLDoc.SaveToFile(Exepath+'xmlDocument.xml');
    XMLDoc.Free;  
   end;
   
   
  procedure TestXML3;
    var
  PassNode: TDOMNode;
  Doc:      TXMLDocument;
 begin
  // Read in xml file from disk
  try
    doc:= ReadXMLFile(exepath+ 'examples\orders.xml');
  except 
    writeln(ExceptionToString(ExceptionType, ExceptionParam));
  end
  // Retrieve the "password" node
  //PassNode := Doc.DocumentElement.FindNode('password');
  // Write out value of the selected node
  WriteLn(PassNode.NodeValue); // will be blank
  // The text of the node is actually a separate child node
  WriteLn(PassNode.FirstChild.NodeValue); // correctly prints "abc"
  // alternatively
  //WriteLn(PassNode.TextContent);
  // finally, free the document
  Doc.Free;
end;

 procedure TMyObjectDOMFromStream(AStream: TStream);
var
  //Parser: TDOMParser;
  //Src: TXMLInputSource;
  TheDoc: TXMLDocument;
begin
  // create a parser object
  (*Parser := TDOMParser.Create;
  // and the input source
  Src := TXMLInputSource.Create(AStream);
  // we want validation
  Parser.Options.Validate := True;
  // assign a error handler which will receive notifications
  Parser.OnError := @ErrorHandler;
  // now do the job
  Parser.Parse(Src, TheDoc);
  // ...and cleanup
  Src.Free;
  Parser.Free;*)
end;

 procedure ProcessNode(Node: TDOMNode; TreeNode: TTreeNode);
  var
    cNode: TDOMNode;
    s: string;
    tree: TTreeView;
  begin
    if Node = nil then Exit; // Stops if reached a leaf
 
    // Adds a node to the tree
    if {Node.HasAttributes and} (Node.Attributes.Length>0) then
      s:=Node.Attributes[0].NodeValue
    else
      s:=''; 
    TreeNode := tree.Items.AddChild(TreeNode, s);
    // Goes to the child node
    cNode := Node.FirstChild;
 
    // Processes all child nodes
    while cNode <> nil do
    begin
      ProcessNode(cNode, TreeNode);
      cNode := cNode.NextSibling;
    end;
  end;


procedure setNForm;

begin
 Form1:= TForm1.create(self)
 with form1 do begin
  Left := 278
  Top := 151
  BorderStyle := bsSingle
  formstyle:= fsstayontop;
  Caption := 'Python Delphi FANN Xor Demo'
  Icon.LoadFromResourceName(HInstance,'NEWREPORT'); //TFANNNETWORK
  ClientHeight := 140
  ClientWidth := 310
  Color := clBtnFace
  Font.Charset := DEFAULT_CHARSET
  Font.Color := clWindowText
  Font.Height := -11
  Font.Name := 'MS Sans Serif'
  Font.Style := []
  OldCreateOrder := False
  Position := poScreenCenter
  PixelsPerInch := 96
  //TextHeight := 13
  Show;
  end;
   LblError:= TLabel.create(self)
   with lblerror do begin
    parent:= form1;
    Left := 120
    Top := 12
    Width := 111
    Height := 13
    Caption := 'Mean Square Error:'
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clWindowText
    Font.Height := -11
    Font.Name := 'MS Sans Serif'
    Font.Style := [fsBold]
    ParentFont := False
  end;
  lblMSE:= TLabel.create(self)
  with lblmse do begin
    parent:= form1;
    Left := 232
    Top := 12
    Width := 5
    Height := 13
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clRed
    Font.Height := -11
    Font.Name := 'MS Sans Serif'
    Font.Style := [fsBold]
    ParentFont := False
  end;
  btnTrain:= TButton.create(self)
  with btntrain do begin
    parent:= form1;
    Left := 8
    Top := 56
    Width := 97
    Height := 25
    Caption := 'Train'
    Enabled := False
    TabOrder := 0
    OnClick := @tform1btnTrainClick;
  end;
  btnRun:= TButton.create(self)
  with btnrun do begin
    parent:= form1
    Left := 8
    Top := 96
    Width := 97
    Height := 25
    Caption := 'Run'
    Enabled := False
    TabOrder := 1
    OnClick := @tform1btnRunClick
  end;
  memoXor:= TMemo.create(self)
  with memoXor do begin
    parent:= form1;
    Left := 120
    Top := 32
    Width := 169
    Height := 89
    ReadOnly := True
    TabOrder := 2
  end;
  btnBuild:= TBitBtn.create(self)
  with btnbuild do begin
  parent:= form1
    Left := 8
    Top := 16
    Width := 97
    Height := 25
    Caption := 'Build'
    glyph.LoadFromRes(getHINSTANCE,'TFANNNETWORK');
    TabOrder := 3
    OnClick := @tform1btnBuildClick;
  end;
  NN:= TFannNetwork.create(self)
  with nn do begin
    {Layers.Strings := (
      '2'
      '3'
      '1') }
    Layers.add('2')
    Layers.add('3')
    Layers.add('1')
      
    LearningRate := 0.699999988079071100
    ConnectionRate := 1.000000000000000000
    TrainingAlgorithm := taFANN_TRAIN_RPROP
    ActivationFunctionHidden := afFANN_SIGMOID
    ActivationFunctionOutput := afFANN_SIGMOID
    //Left := 192
    //Top := 40
  end
end;

begin

 setNForm;
 
 TestXML;
 
 //TestXML3;
 
 //TForm1btnCreateXMLClick(self)

end.

//Doc: http://leenissen.dk/fann/wp/language-bindings/

  (*using System;  
using System.IO;  
using System.Xml;  

public class Sample  
     {  
        public static void Main()  
        {  
           // Create the XmlDocument.  
           XmlDocument doc = new XmlDocument();  
           doc.LoadXml("<book genre='novel' ISBN='1-861001-57-5'>" +  
                       "<title>Pride And Prejudice</title>" +  
                       "</book>");  
   
           // Save the document to a file.  
           doc.Save("data.xml");  
        }  
     }    *)
