unit uMain_odometer_Demo;

interface

{uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, ExtCtrls, Odometer;
                                }
type
  TForm1 = TForm;
  var
    RadioGroupBase: TRadioGroup;
    RadioGroupAni: TRadioGroup;
    ButtonInc: TButton;
    ButtonDec: TButton;
    ButtonSet: TButton;
    EditSet: TEdit;
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    Bevel1: TBevel;
    Odometer1: TOdometer;
    RadioGroupDir: TRadioGroup;
       procedure TForm1RadioGroupBaseClick(Sender: TObject);
       procedure TForm1FormCreate(Sender: TObject);
       procedure TForm1RadioGroupAniClick(Sender: TObject);
       procedure TForm1ButtonIncClick(Sender: TObject);
       procedure TForm1ButtonDecClick(Sender: TObject);
       procedure TForm1ButtonSetClick(Sender: TObject);
       procedure TForm1ScrollBar1Change(Sender: TObject);
       procedure TForm1RadioGroupDirClick(Sender: TObject);
  //private
  //public
  //end;

var
  Form1: TForm1;

implementation

//{$R *.DFM}

procedure TForm1RadioGroupBaseClick(Sender: TObject);
begin
  case TRadioGroup(Sender).ItemIndex of
    0: Odometer1.BaseType := btBinary;
    1: Odometer1.BaseType := btDecimal;
    2: Odometer1.BaseType := btHexadecimal;
  end;
end;

procedure TForm1FormCreate(Sender: TObject);
begin
  RadioGroupBase.ItemIndex := 1;
  RadioGroupAni.ItemIndex := 2;
  RadioGroupDir.ItemIndex := 1;
  ScrollBar1.Position := Odometer1.FrameInterval;
end;

procedure TForm1RadioGroupAniClick(Sender: TObject);
begin
  case TRadioGroup(Sender).ItemIndex of
    0: Odometer1.AnimationType := atNone;
    1: Odometer1.AnimationType := atSynchronous;
    2: Odometer1.AnimationType := atAsynchronous;
  end;
end;

procedure TForm1ButtonIncClick(Sender: TObject);
begin
  Odometer1.Increase;
end;

procedure TForm1ButtonDecClick(Sender: TObject);
begin
  Odometer1.Decrease;
end;

procedure TForm1ButtonSetClick(Sender: TObject);
begin
  Odometer1.Value := StrToInt(EditSet.Text);
end;

procedure TForm1ScrollBar1Change(Sender: TObject);
begin
  Odometer1.FrameInterval := TScrollBar(Sender).Position;
end;

procedure TForm1RadioGroupDirClick(Sender: TObject);
begin
  case TRadioGroup(Sender).ItemIndex of
    0: Odometer1.IncTopToBottom := True;
    1: Odometer1.IncTopToBottom := False;
  end;
end;

procedure loadODOForm;
begin

//object Form1: TForm1
 Form1:= TForm1.create(self)
 with form1 do begin
    Left := 194
     Top := 121
     Width := 290
     Height := 300
     Caption := 'Odometer mX4 demo'
     Font.Charset := DEFAULT_CHARSET
     Font.Color := clWindowText
     Font.Height := -13
     Font.Name := 'MS Sans Serif'
     Font.Style := []
     Position := poDefaultPosOnly
     Scaled := False
     OnCreate := @TForm1FormCreate
     PixelsPerInch := 120
     //TextHeight := 16
     Show;
   end;
  Label1:= TLabel.create(self)
  with label1 do begin
  parent:= form1
    Left := 8
    Top := 224
    Width := 210
    Height := 16
    Caption := 'Animation frame pause (1 - 255 ms):'
  end;
  //object Bevel1: TBevel
  Bevel1:= TBevel.create(self)
  with bevel1 do begin
  parent:= form1
    Left := 143
    Top := 15
    Width := 123
    Height := 22
  end;
  Odometer1:= TOdometer.create(self)
  with odometer1 do begin
   parent:= form1
    Left := 144
    Top := 16
    AnimationType := atSynchronous
    FrameInterval := 30
    BaseType := btDecimal
    DigitCount := 8
    IncTopToBottom := False
    Value := 0
  end ;
  RadioGroupBase:= TRadioGroup.create(self)
  with  RadioGroupBase do begin
  parent:= form1
    Left := 8
    Top := 8
    Width := 121
    Height := 81
    Caption := 'Base type'
    Items.add('Binary')
    items.add('Decimal')
    items.add('Hexadecimal')
    TabOrder := 0
    OnClick := @Tform1RadioGroupBaseClick ;
  end;
  //object RadioGroupAni: TRadioGroup
  RadioGroupAni:= TRadioGroup.create(self)
  with  RadioGroupAni do begin
  parent:= form1
    Left := 8
    Top := 96
    Width := 121
    Height := 81
    Caption := 'Animation'
    Items.add('None')
    items.add('Synchronous')
    items.add('ASynchronous')
    TabOrder := 1
    OnClick := @Tform1RadioGroupAniClick ;
  end ;
  ButtonInc:= TButton.create(self)
  with buttoninc do begin
  parent:= form1
    Left := 144
    Top := 48
    Width := 121
    Height := 25
    Caption := 'Increase'
    TabOrder := 2
    OnClick := @Tform1ButtonIncClick ;
  end;
  //object ButtonDec: TButton
  Buttondec:= TButton.create(self)
  with buttondec do begin
  parent:= form1
    Left := 144
    Top := 80
    Width := 121
    Height := 25
    Caption := 'Decrease'
    TabOrder := 3
    OnClick := @tform1ButtonDecClick ;
  end;
  //object ButtonSet: TButton
  Buttonset:= TButton.create(self)
  with buttonset do begin
  parent:= form1
    Left := 144
    Top := 128
    Width := 121
    Height := 25
    Caption := 'Set decimal value:'
    TabOrder := 4
    OnClick := @tform1ButtonSetClick ;
  end ;
  EditSet:= TEdit.create(form1)
  with editset do begin
   parent:= form1
    Left := 144
    Top := 152
    Width := 121
    Height := 24
    TabOrder := 5
  end;
  ScrollBar1:= TScrollBar.create(self)
  with scrollbar1 do begin
   parent:= form1
    Left := 8
    Top := 240
    Width := 257
    Height := 16
    Max := 255
    Min := 1
    Position := 30
    TabOrder := 6
    OnChange := @tform1ScrollBar1Change;
  end;
  RadioGroupDir:= TRadioGroup.create(form1)
  with radiogroupdir do begin
   parent:= form1
    Left := 8
    Top := 184
    Width := 257
    Height := 33
    Caption := 'Increase direction'
    Columns := 2
    Items.add('Top to bottom')
    items.add('Bottom to top')
    TabOrder := 7
    OnClick := @tform1RadioGroupDirClick;
  end;
end;


var abt: boolean;

begin

  writeln(' odometer with  a form')
  
  loadODOForm;
  TForm1FormCreate(self)
  
  for it:= 1 to 10 do begin
    Tform1ButtonIncClick (self)
    sleep(600)
  end;  
  
  
   (* srlist:= TStringlist.create;
    if LoadDFMFile2Strings('C:\maXbox\EKON_BASTA\EKON23\ForenTage\Import\odometer\demo\uMain.dfm',
                              srlist, abt)  = 0 
    then writeln(srlist.text);
    srlist.Free;
    //          *)
End.




  