unit U_PointInSpace5_2_Form2;

// for maXbox still... in work! , i included u_matrix now`!
{Unit UMatrix is the unit from the old Borland Turbo Pascal  Numeric Toolbox which contains the GuussianElimination procedure used here among other matrix operations. 
Gaussian_Elimination(N,A,B,Xs,MathErr); wont work!}

// http://delphiforfun.org/Programs/Math_Topics/PointFrom4Sensors.htm  

{Copyright  09, Gary Darby,  www.DelphiForFun.org
 This program may be used or modified for any non-commercial purpose
 so long as this original notice remains in place.
 All other rights are reserved
 }

{Given the 3D coordinate locations of four sensors and their reported distance
 from a target, calculate the location of the target. This program develops
 a set of linear equations based on 3D distance equations and solves the
 equartions using Gaussian Elimination}


interface

{uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  shellAPI, StdCtrls, Inifiles, UMatrix, ComCtrls, ExtCtrls, DFFUtils;
  }

type     

  TNvector2 = array[1..TNArraySize] of Float;
  TNmatrix2 = array[1..TNArraySize] of TNvector2;

  TReal3DPoint= record
    x,y,z:extended;
  end;

  TReal3DLine=record
    p1,p2:TReal3DPoint;
  end;


  TRealSphere= record
    p:TReal3DPoint;
    R:extended;
  end;


  TSensorEdits= record
    XEdt,YEdt,ZEdt,DistEdt:TEdit;
    P:TReal3DPoint;
    R:extended;
  end;


  TForm1 = TForm;
  var
    StaticText1: TStaticText;
    RandcaseBtn: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Label7: TLabel;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Label8: TLabel;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit16: TEdit;
    Edit17, Edit18, Edit19, Edit20: TEdit;
    Solvebtn: TButton;
    AnswerLbl: TLabel;
    aMemo2: TMemo;
    GentestBtn: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SaveBtn: TButton;
    LoadBtn: TButton;
    Label11: TLabel;
    TrilaterateBtn: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    aMemo1: TMemo;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    aMemo3: TMemo;
    aMemo4: TMemo;
    Label9: TLabel;
    Caselbl: TLabel;
    VerboseBox: TCheckBox;
       procedure StaticText1Click(Sender: TObject);
       procedure FormCreate(Sender: TObject);
       procedure RandcaseBtnClick(Sender: TObject);
       procedure EditChange(Sender: TObject);
       procedure SolvebtnClick(Sender: TObject);
       procedure GentestBtnClick(Sender: TObject);
       procedure SaveBtnClick(Sender: TObject);
       procedure LoadBtnClick(Sender: TObject);
       procedure TargetKnownClick(Sender: TObject);
       procedure TrilaterateBtnClick(Sender: TObject);
  //public
    {sensor values are in sensors[0] through [3]
     Sensors[4] is used for known solution location if known (for testing)}
    var
    sensors:array[0..4] of TSensorEdits;

    target:TReal3DPoint;
    targetdist:extended;
    theta1,theta2,theta3,theta4:extended;
    N    : Integer;  { Matrix dimension }
    A    : TNMatrix;  { System matrix }
    B    : TNVector;  { Constant vector }
    Xs    : TNVector;  { Solution vector }  //TNVector from u_matrix

       procedure LoadValuesfromEdits;
       procedure LoadEditsFromValues;
       procedure resetResults;
       procedure SetSensorval(N:integer;xx,yy,zz:extended);
       procedure showtarget(show:boolean);
       function  gaussSolve(Inputlabel:string):boolean;
 // end;
 
 const
  aTNNearlyZero = 1E-07;

var
  Form1: TForm1;

implementation

//{$R *.DFM}

var
  nearzero:extended;  //  =1e-5;

{********* Real3DPoint ***********}
function real3dpoint(a,b,c:extended):TReal3DPoint;
{make 3d point from 3 values}
begin
  with result do begin
    x:=a;
    y:=b;
    z:=c;
  end;
end;

{************ Dist3D ************}
function Dist3D(p1,p2:TReal3DPoint):extended;
{3D distance}
begin
  with p1 do result:=sqrt(sqr(p2.x-x)+sqr(p2.y-y)+sqr(p2.z-z));
end;

{*********** LoadvaluesFromEdits *********}
procedure LoadValuesfromEdits;
{called from SolveBtn in case user has changed values}
var
  i:integer;
begin
  for i:=0 to 3 do
  with sensors[i] do begin
    P.x:=strtofloat(XEdt.text);
    P.y:=strtofloat(YEdt.text);
    P.z:=strtofloat(ZEdt.text);
    R:=strtofloat(DistEdt.text);
  end;
  target:=sensors[4].p;
end;

{********* LoadEditsFromvalues *******}
procedure LoadEditsFromValues;
{Called after loading a case to make edits reflect current values}
var
  i:integer;
begin
  for i:=0 to 4 do
  with sensors[i] do begin
    Xedt.text:=format('%.3f',[P.x]);
    Yedt.text:=format('%.3f',[P.y]);
    Zedt.text:=format('%.3f',[P.z]);
    DistEdt.text:=format('%.3f',[R]);
 end;
end;

{*********** FormCreate *************}
procedure FormCreate(Sender: TObject);
var
  i:integer;
  index,ftype:integer;
  //XEdt,YEdt,ZEdt,DistEdt:TEdit;
  sens: TSensorEdits;
begin
  randomize;
  reformatMemo(amemo1);
  for i:=0 to form1.controlcount-1 do
  if (form1.controls[i] is TEdit) then
  with form1.controls[i] do begin
    if (tag>0) and (tag<=20) then begin
      writeln(TEdit(form1.controls[i]).text)
      index:=(tag-1) div 4;
      ftype:=(tag-1) mod 4;
      with sensors[index] do
      case ftype of
        0: begin Xedt:=TEdit(form1.controls[i]);
             writeln('objtostr xedt: '+objtostr(xedt))
           end;
        1: YEdt:=TEdit(form1.controls[i]);
        2: Zedt:=TEdit(form1.controls[i]);
        3: DistEdt:=TEdit(form1.controls[i]);
      end;
    end;
  end;
  for i:= low(sensors) to high(sensors) do begin
    //sens:= sensors[i];
     writeln(itoa(low(sensors))+' : highsensors '+itoa(high(sensors)))  
    with sensors[i] do  begin
      writeln('check R: '+floattostr(R))
      writeln('objtostr2 xedt: '+objtostr(xedt)+'sensor '+itoa(i))
      //writeln('objtostr2 distedt: '+objtostr(distedt))
      try
        xedt.text:='0.00';
        yedt.text:='0.00';
        zedt.text:='0.00';
        distedt.text:='0.00';
      except
        writeln(exceptiontostring(exceptiontype, exceptionparam))
      end;    
    end;
  end;
  opendialog1.InitialDir:=extractfilepath(application.exename);
  savedialog1.InitialDir:=opendialog1.InitialDir;
  GentestBtnClick(sender);
  pagecontrol1.ActivePage:=tabsheet1;
  writeln('form create on create called...');
end;

{********** ResetResults *********8}
procedure resetresults;
{Reset results display}
begin
  with amemo2 do begin
    clear;
    lines.add('Results.display here');
  end;
end;

procedure setSensorval(N:integer;xx,yy,zz:extended);
begin
  with sensors[N], sensors[N].p do begin
    x:=xx;
    y:=yy;
    z:=zz;
    xedt.text:=format('%.3f',[x]);
    yedt.text:=format('%.3f',[y]);
    zedt.text:=format('%.3f',[z]);
    R:=dist3D(p,target);
    distedt.Text:=format('%.3f',[R]);
  end;
end;

{************ GenTestBtnClick *********}
procedure GentestBtnClick(Sender: TObject);
{Make an initial test case}
begin
  resetresults;
  setsensorval(4,5,5,5);  {target point}   //exception
  target:=sensors[4].p;

  setsensorval(0,1,1,1);
  setsensorval(1,1,1,2);
  setsensorval(2,2,1,1);
  setsensorval(3,3,3,3);

  Caselbl.caption:='Simple case 1 (unsaved)';
end;

{********* RandCasebtn **********}
procedure RandcaseBtnClick(Sender: TObject);
{Generate a random case}
var
  i:integer;
begin
  ResetResults;

  with target do begin
    x:=random(1000)/10-50;
    y:=random(1000)/10-50;
    z:=random(1000)/10-50;
    SetSensorVal(4,x,y,z);
  end;

  for i:=0 to 3 do
  //with sensors[i],sensors[i].p do
   // setsensorval(i,random(1000)/10-random(50),random(1000)/10-random(50),
     //                             random(1000)/10-random(50));
   with sensors[i] do
    setsensorval(i,random(1000)/10-random(50),random(1000)/10-random(50),
                                  random(1000)/10-random(50));                                
  caselbl.caption:='Random case (unsaved)';
end;

//(*
{******** ShowTarget **********}
procedure showtarget(show:boolean);
{Show or hide target data}
  begin
    if show then begin
      with target do
      Answerlbl.caption:=format('Test case Target is at (%.3f,%.3f,%.3f)',[x,y,z]);
      Answerlbl.Visible:=true;
      //targetknown.checked:=true;
    end
    else begin
      answerlbl.Visible:=false;
      //targetknown.checked:=false;
    end;
  end;
//*)



{************ EditChange *********}
procedure EditChange(Sender: TObject);
{One of the values edits changed}
begin
  ResetResults;
    if TEdit(sender).Tag <=16 then showtarget(false);
end;


{************ SolveBtnClick ************}
procedure SolvebtnClick(Sender: TObject);

begin
  loadvaluesfromedits;
  amemo2.clear;
  writeln('return solve '+botostr(GaussSolve('Input')));
end;


{*************** GaussSolve ***********}
function GaussSolve(Inputlabel:string):boolean;
var
  I, J : Integer;  { Loop variables }
  p0x, p0y, p0z, r0sqr:extended;
  MathErr:byte;
  s:string;
  d:array[0..3] of extended;
  t:TReal3dPoint;
  aDet : extended;

begin
  N:=3;
  {with sensors[0],sensors[0].p do begin
    p0x:=x;
    p0y:=y;
    p0z:=z;
    r0sqr:=sqr(r)-sqr(x)-sqr(y)-sqr(z);
  end;}
  with sensors[0] do begin
    p0x:=p.x;
    p0y:=p.y;
    p0z:=p.y;
    r0sqr:=sqr(r)-sqr(p.x)-sqr(p.y)-sqr(p.z);
  end;
  
   writeln('matrix shape '+itoa(low(a))+' : '+itoa(high(a)));
    
  {  for i:=1 to 3 do
  with sensors[i],p do begin
    a[i,1]:=-2*(x-p0x);
    a[i,2]:=-2*(y-p0y);
    a[i,3]:=-2*(z-p0z);
    b[i]:=sqr(r)-sqr(x)-sqr(y)-sqr(z)-r0sqr;
  end; }
  
  writeln('sensor solve load1')
  for i:=1 to 3 do 
   with sensors[i] do begin
    a[i][1]:=-2*(p.x-p0x);
    a[i][2]:=-2*(p.y-p0y);
    a[i][3]:=-2*(p.z-p0z);
    b[i]:=sqr(r)-sqr(p.x)-sqr(p.y)-sqr(p.z)-r0sqr;
   end; 
  //end;  //}
  
  //for i:=1 to 3 do 
  //i:= 1
  (* with sensors[1],sensors[0].p do begin
    a[1][1]:=-2*(x-p0x);
    a[1][2]:=-2*(y-p0y);
    a[1][3]:=-2*(z-p0z);
    b[1]:=sqr(r)-sqr(x)-sqr(y)-sqr(z)-r0sqr;
   end;  
  
  //for i:=1 to 3 do 
   with sensors[2],sensors[0].p do begin
    a[2][1]:=-2*(x-p0x);
    a[2][2]:=-2*(y-p0y);
    a[2][3]:=-2*(z-p0z);
    b[2]:=sqr(r)-sqr(x)-sqr(y)-sqr(z)-r0sqr;
   end; 
  //for i:=1 to 3 do 
   with sensors[3],sensors[0].p do begin 
    a[3][1]:=-2*(x-p0x);
    a[3][2]:=-2*(y-p0y);
    a[3][3]:=-2*(z-p0z);
    b[3]:=sqr(r)-sqr(x)-sqr(y)-sqr(z)-r0sqr;
  end;   *)
   
   writeln('sensor solve load2')

  { Display data }
  if verbosebox.Checked then
  with amemo2,amemo2.lines do begin
    add('Linear system:');
    add('                  Coefficients                 Constants');
    for I := 1 to N do begin
      s:='';
      for J := 1 to N do s:=s+'  '+format('%12.6f',[A[I][J]]);
      add(format('%s, %12.6f',[s,B[i]]));
    end;
    add('');

  end;


{ Solve system }           // from unit u_matrix
{procedure Gaussian_Elimination(Dimen        : integer;
                               Coefficients : TNmatrix;
                               Constants    : TNvector;
                           var Solution     : TNvector;
                           var Error        : byte);  }
  //writeln('const: '+floattostr(b[2]))                         
  Gaussian_Elimination(N,A,B,Xs,MathErr);        //wont work!
  //Procedure Determinant( Dimen : integer; Data : TNmatrix; var Det : Float; var Error : byte)');
  Determinant(N, A, aDet, mathErr);
  writeln('Determinant: '+floattostr(aDet))
  //Partial_Pivoting(N,A,B,Xs,MathErr);
  result:=MathErr=0;
  { Write results }
  //matherr:= 0;
  writeln('x math error: '+itoa(MathErr))
  writeln('solution: '+floattostr(Xs[2]))
  with amemo2, amemo2.lines do
  case MathErr of
    0   : begin
            add('Target coordinates (X, Y, Z)');
            add('----------------------------');
            add(format('Calculated: (%12.5f  %12.5f  %12.5f)',[Xs[1],Xs[2],Xs[3]]));
            (*
            If targetknown.checked then
            with target do
            add(format('Input:      (%12.3f  %12.3f  %12.3f)',[x,y,z]));
            *)
            {check target distances from specified values}
            t:=real3dpoint(xs[1],xs[2],xs[3]);
            add('');
            add('Input vs Calculated Distance from Target');
            add('------------------------------------------');

            i:=9-length(Inputlabel) div 2;  {Center the label}
            s:=stringofchar(' ',i);
            s:=s+inputlabel+s;

            add('Sensor' + S + 'Calc     Difference');
            for i:=0 to 3 do begin
              d[i]:=dist3d(sensors[i].p,t);
              add(format('  %d  %12.5f  %12.5f %12.5f',
                         [i+1,sensors[i].R,d[i],sensors[i].r-d[i]]));
            end;
            selstart:=0;
            sellength:=0;
          end;
    2 : amemo2.lines.add('Singular matrix - No solution exists!');
  end;
end;

 {........... SaveSensor ..........}
        procedure savesensor(id:string;data:TSensorEdits; ini: TInifile);
        begin
          with ini, data do begin
            writefloat(id,'X',p.x);
            writefloat(id,'Y',p.y);
            writefloat(id,'Z',p.z);
            writefloat(id,'R',r);
          end;
        end;


{*********** SaveBtnClick **********}
procedure SaveBtnClick(Sender: TObject);
var
  i:integer;
  ini:TInifile;
     (*   {........... SaveSensor ..........}
        procedure savesensor(id:string;data:TSensorEdits);
        begin
          with ini, data do
          begin
            writefloat(id,'X',p.x);
            writefloat(id,'Y',p.y);
            writefloat(id,'Z',p.z);
            writefloat(id,'R',r);
          end;
        end;
       *)
       
begin {SavebtnClick}
  loadvaluesfromedits;
  If savedialog1.execute then begin
    ini:=TInifile.create(Savedialog1.filename);
    with Ini do begin
      writestring('General', 'DecimalSeparator',Decimalseparator);
      for i:=0 to 3 do savesensor('Sensor'+inttostr(i),sensors[i],ini);
      savesensor('Target',sensors[4],ini);
      free;

    end;
    caselbl.Caption:=extractfilename(savedialog1.FileName);
  end;
end;


    {...... Loadsensor .......}
      procedure LoadSensor(id:string;var data:TSensorEdits; ini: TInifile);
      begin
        with ini, data do begin
          p.x:=readfloat(id,'X',0);
          p.y:=readfloat(id,'Y',0);
          p.Z:=readfloat(id,'Z',0);
          R:=readfloat(id,'R',0);
        end;
      end;


{*********** LoadbtnClick ***********}
procedure LoadBtnClick(Sender: TObject);
var
  i:integer;
  ini:TInifile;
  savesep:char;
  decimalstring:string;

  
begin {LoadbtnClick}
  if opendialog1.execute then begin
    ini:=TInifile.create(Opendialog1.filename);
    with Ini do begin
      savesep:=decimalseparator;
      decimalstring:=readstring('General', 'DecimalSeparator',savesep);
      setdecimalseparator(decimalstring[1]);
      for i:=0 to 3 do loadsensor('Sensor'+inttostr(i),sensors[i],ini);
      loadsensor('Target',sensors[4],ini);

      //TargetKnown.checked:=readbool('Target','Known',false);
      target:=sensors[4].p;
      free;
      //decimalseparator:=savesep;
      setdecimalseparator(savesep);

    end;
    caselbl.caption:=extractfilename(opendialog1.FileName);
    loadeditsFromvalues;
    ResetResults;
  end;
end;

procedure loadForm;
begin
Form1:= TForm1.create(self);
with form1 do begin
  Left := 274
  Top := 112
  Width := 1133
  Height := 701
  Caption := 'Point in space from 4 sensors  V5.1'
  Color := clBtnFace
  Font.Charset := DEFAULT_CHARSET
  Font.Color := clWindowText
  Font.Height := -16
  Font.Name := 'Arial'
  Font.Style := []
  OldCreateOrder := False
  OnCreate := @FormCreate
  //PixelsPerInch := 120
  //TextHeight := 18
  Show;
  end;
  Label1:= TLabel.create(form1)
  with label1 do begin
   parent:= form1;
    Left := 612
    Top := 81
    Width := 67
    Height := 18
    Caption := 'Sensor 1 '
  end;
  Label2:= TLabel.create(form1)
  with label2 do begin
   parent:= form1;
    Left := 711
    Top := 56
    Width := 19
    Height := 21
    Caption := 'X:'
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clWindowText
    Font.Height := -18
    Font.Name := 'Arial'
    Font.Style := [fsBold]
    ParentFont := False
  end;
  Label3:= TLabel.create(form1)
  with label3 do begin
   parent:= form1;
    Left := 792
    Top := 56
    Width := 19
    Height := 21
    Caption := 'Y:'
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clWindowText
    Font.Height := -18
    Font.Name := 'Arial'
    Font.Style := [fsBold]
    ParentFont := False
  end;
  Label4:= TLabel.create(form1)
  with label4 do begin
   parent:= form1;
    Left := 873
    Top := 56
    Width := 17
    Height := 21
    Caption := 'Z:'
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clWindowText
    Font.Height := -18
    Font.Name := 'Arial'
    Font.Style := [fsBold]
    ParentFont := False
  end;
 Label5:= TLabel.create(form1)
  with label5 do begin
   parent:= form1;
     Left := 954
    Top := 56
    Width := 41
    Height := 21
    Caption := 'Dist:'
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clWindowText
    Font.Height := -18
    Font.Name := 'Arial'
    Font.Style := [fsBold]
    ParentFont := False
  end;
 Label6:= TLabel.create(form1)
  with label6 do begin
   parent:= form1;
     Left := 612
    Top := 117
    Width := 67
    Height := 18
    Caption := 'Sensor 2 '
  end;
 Label7:= TLabel.create(form1)
  with label7 do begin
   parent:= form1;
     Left := 612
    Top := 153
    Width := 67
    Height := 18
    Caption := 'Sensor 3 '
  end;
 Label8:= TLabel.create(form1)
  with label8 do begin
   parent:= form1;
    Left := 612
    Top := 189
    Width := 67
    Height := 18
    Caption := 'Sensor 4 '
  end ;
  answerlbl:= TLabel.create(form1)
  with answerlbl do begin
   parent:= form1;
    Left := 621
    Top := 549
    Width := 73
    Height := 18
    Caption := 'AnswerLbl'
    Visible := False
  end;
  Label11:= TLabel.create(form1)
  with label11 do begin
   parent:= form1;
    Left := 585
    Top := 27
    Width := 482
    Height := 18
    Caption := 
      'Load, generate, or enter a case and click "Solve" to see the sol' +
      'ution'
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clWindowText
    Font.Height := -15
    Font.Name := 'Arial'
    Font.Style := [fsBold]
    ParentFont := False
  end;
  Label9:= TLabel.create(form1)
  with label9 do begin
   parent:= form1;
    Left := 630
    Top := 369
    Width := 117
    Height := 21
    Caption := 'Current Case: '
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clWindowText
    Font.Height := -18
    Font.Name := 'Arial'
    Font.Style := []
    ParentFont := False
  end ;
  caselbl:= TLabel.create(form1)
  with caselbl do begin
   parent:= form1;
    Left := 630
    Top := 396
    Width := 200
    Height := 21
    Caption := 'Simple case 1 (Unsaved)'
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clWindowText
    Font.Height := -18
    Font.Name := 'Arial'
    Font.Style := []
    ParentFont := False
  end;
  StaticText1:= TStaticText.create(self)
  with statictext1 do begin
   parent:= form1
    Left := 0
    Top := 634
    Width := 1115
    Height := 22
    Cursor := crHandPoint
    Align := alBottom
    Alignment := taCenter
    Caption := 'Copyright '#169' 2008, 2014, 2020  Gary Darby,  maXbox4, www.DelphiForFun.org'
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clBlue
    Font.Height := -15
    Font.Name := 'Arial'
    Font.Style := [fsBold, fsUnderline]
    ParentFont := False
    TabOrder := 0
    OnClick := @StaticText1Click
  end;
  RandcaseBtn:= TButton.create(self)
  with randcasebtn do begin
    parent:= form1;
    Left := 846
    Top := 261
    Width := 199
    Height := 28
    Caption := 'Generate random case'
    TabOrder := 1
    OnClick := @RandcaseBtnClick
  end;
  Edit1:= TEdit.create(form1)
  with edit1 do begin
   parent:= form1;
    Tag := 1
    Left := 711
    Top := 81
    Width := 59
    Height := 26
    TabOrder := 2
    Text := '0.0'
    OnChange := @EditChange
  end ;
  Edit2:= TEdit.create(form1)
  with edit2 do begin
   parent:= form1;
    Tag := 2
    Left := 792
    Top := 81
    Width := 59
    Height := 26
    TabOrder := 3
    Text := '0.0'
    OnChange := @EditChange
  end;
  Edit3:= TEdit.create(form1)
  with edit3 do begin
   parent:= form1;
    Tag := 3
    Left := 873
    Top := 81
    Width := 59
    Height := 26
    TabOrder := 4
    Text := '0.0'
    OnChange := @EditChange
  end ;
 Edit4:= TEdit.create(form1)
  with edit4 do begin
   parent:= form1;   
   Tag := 4
    Left := 954
    Top := 81
    Width := 59
    Height := 26
    TabOrder := 5
    Text := '0.0'
    OnChange := @EditChange
  end;
  Edit5:= TEdit.create(form1)
  with edit5 do begin
   parent:= form1;
    Tag := 5
    Left := 711
    Top := 117
    Width := 59
    Height := 26
    TabOrder := 6
    Text := '0.0'
    OnChange := @EditChange
  end;
  Edit6:= TEdit.create(form1)
  with edit6 do begin
   parent:= form1;
    Tag := 6
    Left := 792
    Top := 117
    Width := 59
    Height := 26
    TabOrder := 7
    Text := '0.0'
    OnChange := @EditChange
  end;
  Edit7:= TEdit.create(form1)
  with edit7 do begin
   parent:= form1;
    Tag := 7
    Left := 873
    Top := 117
    Width := 59
    Height := 26
    TabOrder := 8
    Text := '0.0'
    OnChange := @EditChange
  end ;
 Edit8:= TEdit.create(form1)
  with edit8 do begin
   parent:= form1;
    Tag := 8
    Left := 954
    Top := 117
    Width := 59
    Height := 26
    TabOrder := 9
    Text := '0.0'
    OnChange := @EditChange
  end ;
  Edit9:= TEdit.create(form1)
  with edit9 do begin
   parent:= form1;
    Tag := 9
    Left := 711
    Top := 153
    Width := 59
    Height := 26
    TabOrder := 10
    Text := '0.0'
    OnChange := @EditChange
  end ;
  Edit10:= TEdit.create(form1);
  with edit10 do begin
   parent:= form1;
    Tag := 10
    Left := 792
    Top := 153
    Width := 59
    Height := 26
    TabOrder := 11
    Text := '0.0'
    OnChange := @EditChange
  end ;
  Edit11:= TEdit.create(form1);
  with edit11 do begin
   parent:= form1;
    Tag := 11
    Left := 873
    Top := 153
    Width := 59
    Height := 26
    TabOrder := 12
    Text := '0.0'
    OnChange := @EditChange
  end ;
  Edit12:= TEdit.create(form1);
  with edit12 do begin
   parent:= form1;
    Tag := 12
    Left := 954
    Top := 153
    Width := 59
    Height := 26
    TabOrder := 13
    Text := '0.0'
    OnChange := @EditChange
  end;
  Edit13:= TEdit.create(form1);
  with edit13 do begin
   parent:= form1;
    Tag := 13
    Left := 711
    Top := 189
    Width := 59
    Height := 26
    TabOrder := 14
    Text := '0.0'
    OnChange := @EditChange
  end ;
 Edit14:= TEdit.create(form1);
  with edit14 do begin
   parent:= form1;
    Tag := 14
    Left := 792
    Top := 189
    Width := 59
    Height := 26
    TabOrder := 15
    Text := '0.0'
    OnChange := @EditChange
  end;
  Edit15:= TEdit.create(form1);
  with edit15 do begin
   parent:= form1;
       Tag := 15
    Left := 873
    Top := 189
    Width := 59
    Height := 26
    TabOrder := 16
    Text := '0.0'
    OnChange := @EditChange
  end ;
  Edit16:= TEdit.create(form1);
  with edit16 do begin
   parent:= form1;
    Tag := 16
    Left := 954
    Top := 189
    Width := 59
    Height := 26
    TabOrder := 17
    Text := '0.0'
    OnChange := @EditChange;
  end ;
    Edit17:= TEdit.create(form1);
  with edit17 do begin
   parent:= form1;
    Tag := 17
    Left := 711
    Top := 225
    Width := 59
    Height := 26
    TabOrder := 14
    Text := '0.0'
    OnChange := @EditChange
  end ;
 Edit18:= TEdit.create(form1);
  with edit18 do begin
   parent:= form1;
    Tag := 18
    Left := 792
    Top := 225
    Width := 59
    Height := 26
    TabOrder := 15
    Text := '0.0'
    OnChange := @EditChange
  end;
  Edit19:= TEdit.create(form1);
  with edit19 do begin
   parent:= form1;
    Tag := 19
    Left := 873
    Top := 225
    Width := 59
    Height := 26
    TabOrder := 16
    Text := '0.0'
    OnChange := @EditChange
  end ;
  Edit20:= TEdit.create(form1);
  with edit20 do begin
   parent:= form1;
    Tag := 20
    Left := 954
    Top := 225
    Width := 59
    Height := 26
    TabOrder := 17
    Text := '0.0'
    OnChange := @EditChange;
  end ;

  Solvebtn:= TButton.create(form1)
  with solvebtn do begin
    parent:= form1
    Left := 621
    Top := 477
    Width := 217
    Height := 28
    Caption := 'Gaussian Elimination'
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clWindowText
    Font.Height := -18
    Font.Name := 'Arial'
    Font.Style := [fsBold]
    ParentFont := False
    TabOrder := 18
    OnClick := @SolvebtnClick
  end ;
   aMemo2:= TMemo.create(form1)
   with amemo2 do begin
    parent:= form1
    Left := 18
    Top := 414
    Width := 568
    Height := 208
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clWindowText
    Font.Height := -15
    Font.Name := 'Courier New'
    Font.Style := []
    Lines.add('Results display here')
    ParentFont := False
    ScrollBars := ssVertical
    TabOrder := 19
  end ;
  gentestbtn:= TButton.create(form1)
  with gentestbtn do begin
    parent:= form1
    Left := 621
    Top := 261
    Width := 199
    Height := 28
    Caption := 'Generate Simple case 1'
    TabOrder := 20
    OnClick := @GentestBtnClick
  end;
  Savebtn:= TButton.create(form1)
  with savebtn do begin
    parent:= form1
    Left := 846
    Top := 315
    Width := 199
    Height := 28
    Caption := 'Save Case'
    TabOrder := 21
    OnClick := @SaveBtnClick
  end ;
  loadbtn:= TButton.create(form1)
  with loadbtn do begin
    parent:= form1
    Left := 621
    Top := 315
    Width := 199
    Height := 28
    Caption := 'Load case'
    TabOrder := 22
    OnClick := @LoadBtnClick
  end ;
  trilateratebtn:= TButton.create(form1)
  with trilateratebtn do begin
    parent:= form1
    Left := 864
    Top := 477
    Width := 190
    Height := 28
    Caption := 'Trilateration'
    Font.Charset := DEFAULT_CHARSET
    Font.Color := clWindowText
    Font.Height := -18
    Font.Name := 'Arial'
    Font.Style := [fsBold]
    ParentFont := False
    TabOrder := 23
    OnClick := @TrilaterateBtnClick
  end ;
  PageControl1:= TPageControl.create(form1)
  with pagecontrol1 do begin
   parent:= form1;
    Left := 9
    Top := 18
    Width := 559
    Height := 379
    ActivePage := TabSheet1
    TabOrder := 24
    TabSheet1:= TTabSheet.create(self)
    with tabsheet1 do begin
      parent:= pagecontrol1; //form1
      pagecontrol:= pagecontrol1
      Caption := 'Introduction'
      aMemo1:= TMemo.create(self)
      with amemo1 do begin
       parent:= tabsheet1
        Left := 0
        Top := 0
        Width := 551
        Height := 346
        Align := alClient
        Color := 14548991
        Lines.add(
            'We have 4 sensors at known locations in 3D space. Each sensor ca' +
            'n '+
          'supply'+
            'distance information to a target but knows nothing about the tar' +
            'get'#39's '+
          'direction.'+CRLF+CRLF+
            'Alternatively, the sensors are Satellites and the target is a GP' +
            'S receiver '+
          'which'+
            'reads very accurate time stamps transmitted by the satellites an' +
            'd '+
          'calculates'+
            'distances based on time offsets between its clock and satellites' +
            #39' clocks.'+
          ''+ CRLF+ CRLF+
            'Given the sensor (X,Y,Z) coordinates and their reported distance' +
            '-to-target'+
            'values, we want to determine the target location.  The program u' +
            'ses either '+
          'of'+
            'two methods to locate the target object; "Gaussian Elimination" ' +
            'or'+
            '"Trilateration" which is new with Version 5 of the program.  In ' +
            'both methods, '+
          'a ' +
            'set of distance equations is solved based finding the single int' +
            'ersection '+
          'point of '  +
            'spheres centered on the sensors with radii equal to the sensor'#39's' +
            ' (or the ' +
          'target'#39's) '+
          'estimate of the distance to (or from) the target.'+
          '' +CRLF+ CRLF+             +
            'Note that, in general, the problem requires 4 equations to narro' +
            'w solutions '  +
          'to a '            +
            'single point.  Two sensors can narrow target location down to a ' +
            'circle (the ' +
            'intersection of 2 spheres with target distances as radii), the 3' +
            'rd sensor can '+
            'narrow the location down to two possible points, (the intersecti' +
            'on of the '     +
          'circle '           +
            'with the 3rd sensor'#39's sphere). The 4th sensor'#39's distance should ' +
            'determine '   +
            'which of those two points is the target.  Any error in specified' +
            ' locations or ' +
            'distances would either have no solution or require that some inp' +
            'ut values '    +
          'be '             +
          'adjusted.'       +
          ''+CRLF                +CRLF+
          'The techniques applied here result in reported distances being'+
            'adjusted to produce a solution if necessary.  Differences betwee' +
            'n input and ' +
            'calculated distances are listed as part of the solution.  The do' +
            'wnload for '   +
          'this '           +
            'program includes an unfiltered set of test cases created during ' +
            'testing.  At '  +
          'least '           +
            'one case, "Random1.ini", returns significantly different results' +
            ' for the two '  +
          'methods and needs further investigation.')
        ScrollBars := ssVertical
        TabOrder := 0
      end ;
    end;
    TabSheet2:= TTabSheet.create(self)
    with tabsheet2 do begin
      parent:= pagecontrol1; //form1
      pagecontrol:= pagecontrol1
    
      Caption := '   Gaussian Elimination  '
      ImageIndex := 1
      aMemo3:= TMemo.create(self)
      with amemo3 do begin
       parent:= tabsheet2
        Left := 0
        Top := 0
        Width := 551
        Height := 346
        Align := alClient
        Color := 14548991
        Lines.add(
            'Gaussian Elimination is a technique used to solve a set of linea' +
            'r equations. '+
          'The '           +
            '4 distances equation describing the distance from a sensor to th' +
            'e target '   +
          'can be '        +
            'reduce to three liniear equations by subtracting one of the equa' +
            'tions from '  +
          'the '            +
          'other 3.'        +
          ''   + CRLF+ CRLF            +
            'The set of linear equations describing the problem are derived a' +
            's follows:' +
          ''             +
            'The distance Di to target at (Xt,Yt,Zt) for sensor "i" located a' +
            't'          +
          
            '(Ai, Bi, Ci) is given by Sqr(Di):=Sqr((Ai - Xt) + Sqr(Bi - Yt) + ' +
            'Sqr(Ci - -Zt)' +
          ''                 +
            ':=:=> Di^2 := Ai^2 - 2AiXt + Xt^2 +Bi^2 - 2BiYt +Yt^2 +Ci^2 - 2CiZt' +
            ' + Zt^2'         +
          '' + CRLF+ CRLF                 +
          'We can subtract the Sensor1 equation  from each of the other 3'+
          'to obtain linear equations like the following example  for'     +
          'Sensor2::'                                                      +
          ''                   +
          '2(A1-A2)Xt + 2(B1-B2)Yt + 2((C1-C2)Zt'  +
            '            := D2^2 - A2^2 - B2^2 - C2^2 - D1^2 + A1^2 + B1^2 + C' +
            '1^2'                            +
          ''                                  +
          'The resulting 3 equations in 3 unknowns form a system of linear'+
          'equations which are solved using Gaussian Elimination to find'   +
          'the (Xt, Yt, Zt) target coordinates.'                            +
          ''   + CRLF+ CRLF                            +
            'The "Gaussian Elimination" button assumes that errors are caused' +
            ' by a'                         +
          'clock synchronization error between a satellite and the GPS'+
            'receiver, resulting in a constant error for each distance calcul' +
            'ated.'                     +
            'By iteratively adding 1/2 the difference bewteen the previous in' +
            'put'                        +
          'distance and the newly calculated distance in each step, we can'+
          'converge results to near zero differences.')
        ScrollBars := ssVertical
        TabOrder := 0
      end;
    end;
     TabSheet3:= TTabSheet.create(self)
    with tabsheet3 do begin
      parent:= pagecontrol1; //form1
      pagecontrol:= pagecontrol1
      Caption := '   Trilateration   '
      ImageIndex := 2
      aMemo4:= TMemo.create(self)
      with amemo4 do begin
       parent:= tabsheet3
        Left := 0
        Top := 0
        Width := 551
        Height := 346
        Align := alClient
        Color := 14548991
        Lines.add(
            'Trilateration is another technique, mathematically exact this ti' +
            'me, to find the ' +
            'intersection point of 3 spheres by finding the point of the tetr' +
            'ahedron '          +
          'formed by'            +
            'three of the given points and their distances from the target.  ' +
            'The Wikipedia '      +
            'article on "Trilateration" provides an excellent derivation of t' +
            'he mathematics '      +
          'behind the method.'      +
          ''        + CRLF+ CRLF                 +
            'As an experiment,  I coded the calculation and here apply it to ' +
            'each '                   +
          'combination of'             +
            'three of the four sensor locations given (Sensors (1,2,3), (1,2,' +
            '4),(1,3,4), '              +
          'and '                         +
            '(2,3,4) .  There may be two results for each calculation represe' +
            'nting the '                  +
          'target '                        +
            'on either side of the triangle formed by the three sensors used.' +
            ' Results of '                  +
          'each '                            +
            'calculation are saved and the set with the smallest sum of diffe' +
            'rences from '                    +
          'the '                               +
          'input distance is defined as the solution.'+
          ''   + CRLF+ CRLF             +
            'The solutions tested so far agree with Gaussian method results, ' +
            'but this'       +
            'methos is more robust, solving the case below which Gaussian fai' +
            'ls to '          +
          'solve; '            +
            '(x,y,z,r): P1:(0,0,0,10), P2:(10,0,0,10), P3:(0,10,0,10), P4:(10' +
            ',10,0,10).  '      +
          'This '                +
          'case is included with the download as TestCase5.ini.')
        ScrollBars := ssVertical
        TabOrder := 0
      end;
    end ;
  end  ;
  verboseBox:= TCheckBox.create(form1)
  with verbosebox do begin
  parent:= form1
    Left := 630
    Top := 450
    Width := 316
    Height := 19
    Caption := 'Solve Verbose (show more result detail)'
    TabOrder := 25
  end ;
  OpenDialog1:= TOpenDialog.create(form1);
  with opendialog1 do begin
    DefaultExt := 'ini'
    Filter := 'Case files (*.ini)|*.ini|All files (*.*)|*.*'
    //Left := 752
    //Top := 520
  end ;
  saveDialog1:= TSaveDialog.create(form1);
  with savedialog1 do begin
    DefaultExt := 'ini'
    Filter := 'Case files (*.ini)|*.ini|All files (*.*)|*.*'
    //Left := 816
    //Top := 512
  end;
  FormCreate(self)
end;


procedure StaticText1Click(Sender: TObject);
begin
  //ShellExecute(Handle, 'open', 'http://www.delphiforfun.org/',
  //nil, nil, SW_SHOWNORMAL) ;
end;

procedure TargetKnownClick(Sender: TObject);
begin
  //showtarget(targetknown.checked); {show or hide target info}
end;

type
  Vec3D = record
    x,y,z:double;
  end;


  {Find the 2 possible solutions using the first 3 equations}
(*
   #include <stdio.h>
#include <math.h>

/* No rights reserved (CC0, see http://wiki.creativecommons.org/CC0_FAQ).
 * The author has waived all copyright and related or neighboring rights
 * to this program, to the fullest extent possible under law.
*/

/* Largest nonnegative number still considered zero */
#define   MAXZERO  0.0

typedef struct vec3d    vec3d;
struct vec3d {
        double  x;
        double  y;
        double  z;
};
/* Return the difference of two vectors, (vector1 - vector2). */
vec3d vdiff(const vec3d vector1, const vec3d vector2)
{
        vec3d v;
        v.x = vector1.x - vector2.x;
        v.y = vector1.y - vector2.y;
        v.z = vector1.z - vector2.z;
        return v;
}
*)

function vdiff(const vector1, vector2:vec3d ):vec3d;
begin
  with result do begin
    x := vector1.x - vector2.x;
    y := vector1.y - vector2.y;
    z := vector1.z - vector2.z;
  end
end;

(*
/* Return the sum of two vectors. */
vec3d vsum(const vec3d vector1, const vec3d vector2)
{
        vec3d v;
        v.x = vector1.x + vector2.x;
        v.y = vector1.y + vector2.y;
        v.z = vector1.z + vector2.z;
        return v;
}
*)

function vsum(const vector1, vector2:vec3d):vec3d;
begin
  with result do begin
    x := vector1.x + vector2.x;
    y := vector1.y + vector2.y;
    z := vector1.z + vector2.z;
  end;
end;

(*
/* Multiply vector by a number. */
vec3d vmul(const vec3d vector, const double n)
{
        vec3d v;
        v.x = vector.x * n;
        v.y = vector.y * n;
        v.z = vector.z * n;
        return v;
}
*)

function vmul(const vector:vec3d; const n:double):vec3d;
begin
  with result do begin
    x := vector.x * n;
    y := vector.y * n;
    z := vector.z * n;
  end;
end;

(*
//* Divide vector by a number. */
 vec3d vdiv(const vec3d vector, const double n)
{
        vec3d v;
        v.x = vector.x / n;
        v.y = vector.y / n;
        v.z = vector.z / n;
        return v;
}
*)

function vdiv(const vector:vec3d;  const n:double):vec3d;
begin
  with result do begin
    x := vector.x / n;
    y := vector.y / n;
    z := vector.z / n;
  end;
end;

(*
/* Return the Euclidean norm. */
double vnorm(const vec3d vector)
{
        return sqrt(vector.x * vector.x + vector.y * vector.y + vector.z * vector.z);
}
*)

function vnorm(const vector:vec3d):double;
begin
  result:=sqrt(vector.x * vector.x + vector.y * vector.y + vector.z * vector.z);
end;

(*
/* Return the dot product of two vectors. */
double dot(const vec3d vector1, const vec3d vector2)
{
    return vector1.x * vector2.x + vector1.y * vector2.y + vector1.z * vector2.z;
}

*)

function dot(const vector1, vector2:vec3d):double;
begin
  result:=vector1.x * vector2.x + vector1.y * vector2.y + vector1.z * vector2.z;
end;


(*
/* Replace vector with its cross product with another vector. */
vec3d cross(const vec3d vector1, const vec3d vector2)
{
        vec3d v;
        v.x = vector1.y * vector2.z - vector1.z * vector2.y;
        v.y = vector1.z * vector2.x - vector1.x * vector2.z;
        v.z = vector1.x * vector2.y - vector1.y * vector2.x;
        return v;
}
*)
function cross(vector1,vector2:vec3d):vec3d;
begin
  with result do begin
    x := vector1.y * vector2.z - vector1.z * vector2.y;
    y := vector1.z * vector2.x - vector1.x * vector2.z;
    z := vector1.x * vector2.y - vector1.y * vector2.x;
  end;
end;


(*
/* Return zero if successful, negative error otherwise.
 * The last parameter is the largest nonnegative number considered zero;
 * it is somewhat analoguous to machine epsilon (but inclusive).
*/
int trilateration(vec3d *const result1, vec3d *const result2,
                  const vec3d p1, const double r1,
                  const vec3d p2, const double r2,
                  const vec3d p3, const double r3,
                  const double maxzero)
{
        vec3d   ex, ey, ez, t1, t2;
        double  h, i, j, x, y, z, t;

        /* h = |p2 - p1|, ex = (p2 - p1) / |p2 - p1| */
        ex = vdiff(p2, p1);
        h = vnorm(ex);
        if (h <= maxzero) {
                /* p1 and p2 are concentric. */
                return -1;
        }
        ex = vdiv(ex, h);

        /* t1 = p3 - p1, t2 = ex (ex . (p3 - p1)) */
        t1 = vdiff(p3, p1);
        i = dot(ex, t1);
        t2 = vmul(ex, i);

        /* ey = (t1 - t2), t = |t1 - t2| */
        ey = vdiff(t1, t2);
        t = vnorm(ey);
        if (t > maxzero) {
                /* ey = (t1 - t2) / |t1 - t2| */
                ey = vdiv(ey, t);

                /* j = ey . (p3 - p1) */
                j = dot(ey, t1);
        } else
                j = 0.0;

        /* Note: t <= maxzero implies j = 0.0. */
        if (fabs(j) <= maxzero)
        {
                /* p1, p2 and p3 are colinear. */

                /* Is point p1 + (r1 along the axis) the intersection? */
                t2 = vsum(p1, vmul(ex, r1));
                if (fabs(vnorm(vdiff(p2, t2)) - r2) <= maxzero &&
                    fabs(vnorm(vdiff(p3, t2)) - r3) <= maxzero)
                {
                        /* Yes, t2 is the only intersection point. */
                        if (result1)
                                *result1 = t2;
                        if (result2)
                                *result2 = t2;
                        return 0;
                }

                /* Is point p1 - (r1 along the axis) the intersection? */
                t2 = vsum(p1, vmul(ex, -r1));
                if (fabs(vnorm(vdiff(p2, t2)) - r2) <= maxzero &&
                    fabs(vnorm(vdiff(p3, t2)) - r3) <= maxzero)
                 {
                        /* Yes, t2 is the only intersection point. */
                        if (result1)
                                *result1 = t2;
                        if (result2)
                                *result2 = t2;
                        return 0;
                }

                return -2;
        }

        /* ez = ex x ey */
        ez = cross(ex, ey);

        x = (r1*r1 - r2*r2) / (2*h) + h / 2;
        y = (r1*r1 - r3*r3 + i*i) / (2*j) + j / 2 - x * i / j;
        z = r1*r1 - x*x - y*y;
        if (z < -maxzero) {
                /* The solution is invalid. */
                return -3;
        } else
        if (z > 0.0)
                z = sqrt(z);
        else
                z = 0.0;

        /* t2 = p1 + x ex + y ey */
        t2 = vsum(p1, vmul(ex, x));
        t2 = vsum(t2, vmul(ey,
         y));

        /* result1 = p1 + x ex + y ey + z ez */
        if (result1)
                *result1 = vsum(t2, vmul(ez, z));

        /* result1 = p1 + x ex + y ey - z ez */
        if (result2)
                *result2 = vsum(t2, vmul(ez, -z));

        return 0;
}

*)

function equal(p1,p2:vec3d):boolean;
begin
  result:=(p1.x=p2.x) and (p1.y=p2.y) and (p1.z=p2.z);
end;


// Return zero if successful, negative error otherwise.
// * The last parameter is the largest nonnegative number considered zero;
// * it is somewhat analoguous to machine epsilon (but inclusive).
///
function  trilateration(var result1, result2:vec3d;
                  const p1:vec3d; const r1:double;
                  const p2:vec3d; const r2:double;
                  const p3:vec3d; const r3:double;
                  const nearzero:double):integer;
var
  ex, ey, ez, t1, t2 : vec3d;
      h, i, j, x, y, z, t:double;

     // h = |p2 - p1|, ex = (p2 - p1) / |p2 - p1| */

begin
  result:=0;
  ex := vdiff(p2, p1);
  h := vnorm(ex);
  if (h <= nearzero) then
   //* p1 and p2 are concentric. */
  begin
    result:=-1;
    exit;
  end;
  ex := vdiv(ex, h);
  //* t1 = p3 - p1, t2 = ex (ex . (p3 - p1)) */
  t1 := vdiff(p3, p1);
  i := dot(ex, t1);
  t2 := vmul(ex, i);

  //* ey = (t1 - t2), t = |t1 - t2| */
  ey := vdiff(t1, t2);
  t := vnorm(ey);
  if (t > nearzero) then
  begin //* ey = (t1 - t2) / |t1 - t2| */}
    ey := vdiv(ey, t);
    //* j = ey . (p3 - p1) */
    j := dot(ey, t1);
  end
  else  j := 0.0;//* Note: t <= maxzero implies j = 0.0. */

  if (abs(j) <= nearzero) then begin
    //* p1, p2 and p3 are colinear. */

    //* Is point p1 + (r1 along the axis) the intersection? */
    t2 := vsum(p1, vmul(ex, r1));
    if (abs(vnorm(vdiff(p2, t2)) - r2) <= nearzero)and
              (abs(vnorm(vdiff(p3, t2)) - r3) <= nearzero) then
    begin
      //* Yes, t2 is the only intersection point. */
      //if {(result1) *} equal(result1,t2) then
      //if {(result2) *} equal(result2, t2)
      result1:=t2;
      result2:=t2;
      //result:=0;            ;
      exit;
    end
    else begin
      //* Is point p1 - (r1 along the axis) the intersection? */
      t2 := vsum(p1, vmul(ex, -r1));
      if (abs(vnorm(vdiff(p2, t2)) - r2) <= nearzero) and
            (abs(vnorm(vdiff(p3, t2)) - r3) <= nearzero) then begin
        //* Yes, t2 is the only intersection point. */
        //if {(result1) *}equal(result1,t2)
        result1:=t2;

        //then if {(result2)*} equal(result2,t2)
          //   then
          //   begin
        result2:=t2;
        //result:=0;
        exit;
      end

      //    (* ????
      else begin
        result:= -2;
        exit;
      end;
    end;
    //  *)
  end else begin

    //* ez = ex x ey */
    ez := cross(ex, ey);
    x := (r1*r1 - r2*r2) / (2*h) + h / 2;
    y := (r1*r1 - r3*r3 + i*i) / (2*j) + j / 2 - x * i / j;
    z := r1*r1 - x*x - y*y;
    if (z < -nearzero) then
    begin  //* The solution is invalid. */
      result:=-3;
      exit;
    end else
    if (z > 0.0) then z := sqrt(z)
    else z := 0.0;

    //* t2 = p1 + x ex + y ey */
    t2 := vsum(p1, vmul(ex, x));
    t2 := vsum(t2, vmul(ey, y));

    //* result1 = p1 + x ex + y ey + z ez */
    result1:=vsum(t2, vmul(ez, z));

    //* result1 = p1 + x ex + y ey - z ez */
    result2:=vsum(t2, vmul(ez, -z));
    //result:=0;
    exit;
  end;
end;


(*
int main(void)
{
        vec3d   p1, p2, p3, o1, o2;
        double  r1, r2, r3;
        int     result;

        while (fscanf(stdin, "%lg %lg %lg %lg %lg %lg %lg %lg %lg %lg %lg %lg",
                             &p1.x, &p1.y, &p1.z, &r1,
                             &p2.x, &p2.y, &p2.z, &r2,
                             &p3.x, &p3.y, &p3.z, &r3) == 12) {
                printf("Sphere 1: %g %g %g, radius %g\n", p1.x, p1.y, p1.z, r1);
                printf("Sphere 2: %g %g %g, radius %g\n", p2.x, p2.y, p2.z, r2);
                printf("Sphere 3: %g %g %g, radius %g\n", p3.x, p3.y, p3.z, r3);
                result = trilateration(&o1, &o2, p1, r1, p2, r2, p3, r3, MAXZERO);
                if (result)
                        printf("No solution (%d).\n", result);
                else {
                        printf("Solution 1: %g %g %g\n", o1.x, o1.y, o1.z);
                        printf("  Distance to sphere 1 is %g (radius %g)\n", vnorm(vdiff(o1, p1)), r1);
                        printf("  Distance to sphere 2 is %g (radius %g)\n", vnorm(vdiff(o1, p2)), r2);
                        printf("  Distance to sphere 3 is %g (radius %g)\n", vnorm(vdiff(o1, p3)), r3);
                        printf("Solution 2: %g %g %g\n", o2.x, o2.y, o2.z);
                        printf("  Distance to sphere 1 is %g (radius %g)\n", vnorm(vdiff(o2, p1)), r1);
                        printf("  Distance to sphere 2 is %g (radius %g)\n", vnorm(vdiff(o2, p2)), r2);
                        printf("  Distance to sphere 3 is %g (radius %g)\n", vnorm(vdiff(o2, p3)), r3);
                }
        }

        return 0;
}
*)

 {---------- Loadvec ----------}
    function loadvec(p:TReal3DPoint):vec3d;
    {transfer sensor TReal3DPoint records ro vwc2D type records}
    begin
      result.x:=p.x;
      result.y:=p.y;
      result.z:=p.z;
    end;

     {------------- Loadtrilatdata ----------}
  procedure loadtrilatdata(i,j,k:integer; var P1,P2,P3: vec3d; var r1,r2,r3:double);
  begin
    p1:=loadvec(sensors[i].p);
    p2:=loadvec(sensors[j].p);
    p3:=loadvec(sensors[k].p);
    //writeln('first '+floattostr(p1.x))
    r1:=sensors[i].R;
    r2:=sensors[j].R;
    r3:=sensors[k].R;
    //println(format('%f, %f, %f, %f, %f, %f,', [ p1.x,p2.x,p3.x,r1,r2,r3]))
    //println(format('%f, %f, %f, %f, %f, %f,', [ p1.y,p2.y,p3.y,r1,r2,r3]))
    //println(format('%f, %f, %f, %f, %f, %f,', [ p1.z,p2.z,p3.z,r1,r2,r3]))
  end;  //*)

 var scount:integer;
      r:integer;
      saved:array[1..4] of array[1..2] of vec3d;
  

  {----------- TriLat --------}
procedure trilat(i,j,k: integer); 
{Solve 3 spheres problem for sensors i, j, and k}
var
  p1,p2,p3:vec3d;
  r1,r2,r3:double;
  o1,o2:vec3d;
  temp:vec3d;
  msg:string;
  //  scount:integer;
  //saved: array[1..4] of array[1..2] of vec3d;

begin
  loadtrilatData(i,j,k,P1,P2,P3,r1,r2,r3);
  r:=trilateration(o1, o2, p1, r1, p2, r2, p3, r3, nearzero);
  if o1.x>o2.x then
  begin   {swap so that smaller x is first solution}
    temp:=o1;
    o1:=o2;
    o2:=temp;
  end;

  with amemo2.lines do
  if r<>0 then begin
    case r of
      -1: msg:='Two spheres are concentric';
      -2: msg:='Spheres do not intersect';
      -3: msg:='Spheres do not intersect';
    end;
    add(format('No solution, result=%d: %s',[r,msg]))
  end else begin
    if verbosebox.checked then begin
    {for debugging}
      add('');
      add(format('Solution 1: %f %f %f',[o1.x, o1.y, o1.z]));
  
      add(format('  Distance to sphere %d is %.3f (radius %.3f)', 
                [i+1,vnorm(vdiff(o1, p1)), r1]));
      add(format('  Distance to sphere %d is %.3f (radius %.3f)', 
                [j+1,vnorm(vdiff(o1, p2)), r2]));
      add(format('  Distance to sphere %d is %.3f (radius %.3f)', 
                [k+1,vnorm(vdiff(o1, p3)), r3]));

      add(format('Solution 2: %f %f %f',[o2.x, o2.y, o2.z]));

      add(format('  Distance to sphere %d is %.3f (radius %.3f)', 
                [i+1,vnorm(vdiff(o2, p1)), r1]));
      add(format('  Distance to sphere %d is %.3f (radius %.3f)', 
                 [j+1,vnorm(vdiff(o2, p2)), r2]));
      add(format('  Distance to sphere %d is %.3f (radius %.3f)', 
      [k+1,vnorm(vdiff(o2, p3)), r3]));
    end;

    inc(scount);
    saved[scount][1]:=o1;
    saved[scount][2]:=o2;
  end;
end;
  //*)


{*********** TrilaterateBtnClick ***********8}
procedure TrilaterateBtnClick(Sender: TObject);
//var
  //r:integer;
  //saved:array[1..4] of array[1..2] of vec3d;
  //scount:integer;

{begin  
  //trilat(r,scount,saved)
end;  
}  


var
  i,j,k:integer;
  sumdiff1, sumdiff2:double;
  p1,p2,p3,p4:VEC3D;
  r1,r2,r3,r4:DOUBLE;
  o1,o2:vec3d;
//  scount:integer;

begin
   nearzero:=1e-5;
  //trilat(i,j,k);
  loadvaluesfromedits;
  Amemo2.Clear;
  scount:= 0;
  trilat(0,1,2);
  trilat(0,1,3);
  trilat(0,2,3);
  trilat(1,2,3);

  if scount>0 then begin
    sumdiff1:=0;
    sumdiff2:=0;
    for i:=2 to scount do begin
      sumdiff1:=sumdiff1+abs(saved[1][1].x-saved[i][1].x)
                        +abs(saved[1][1].y-saved[i][1].y)
                        +abs(saved[1][1].z-saved[i][1].z);
      sumdiff2:=sumdiff2+abs(saved[1][2].x-saved[i][2].x)
                        +abs(saved[1][2].y-saved[i][2].y)
                        +abs(saved[1][2].z-saved[i][2].z)
    end;
    if verbosebox.Checked then begin
      amemo2.lines.add('Sum of coordinate differences:');
      amemo2.lines.add(format('  Solution 1: %.5f, Solution #2: %.5f',
                        [sumdiff1, sumdiff2]));
    end;
    P1:=loadvec(sensors[0].p);  r1:=sensors[0].r;
    p2:=loadvec(sensors[1].p);  r2:=sensors[1].r;
    P3:=loadvec(sensors[2].p);  r3:=sensors[2].r;
    p4:=loadvec(sensors[3].p);  r4:=sensors[3].r;
    o1:=saved[1][1]; o2:=saved[1][2];

    with amemo2.lines do
    if sumdiff1<sumdiff2 then begin
      Add('Using Solution 1 set');
      add(format('Solution 1: %f %f %f',[o1.x, o1.y, o1.z]));

      add(format('  Distance to sphere %d is %.5f (vs. measured %.5f)',
       [1,vnorm(vdiff(o1, p1)), r1]));
      add(format('  Distance to sphere %d is %.5f (vs. measured %.5f)',
       [2,vnorm(vdiff(o1, p2)), r2]));
      add(format('  Distance to sphere %d is %.5f (vs. measured %.5f)',
       [3,vnorm(vdiff(o1, p3)), r3]));
      add(format('  Distance to sphere %d is %.5f (vs. measured %.5f)',
       [4,vnorm(vdiff(o1, p4)), r4]));
    end
    else begin
      Add('Use Solution 2 set');
      add(format('Solution 2: %f %f %f',[o2.x, o2.y, o2.z]));
      add(format('  Distance to sphere %d is %.5f (vs. measured %.5f)',
       [1,vnorm(vdiff(o2, p1)), r1]));
      add(format('  Distance to sphere %d is %.5f (vs. measured %.5f)',
       [2,vnorm(vdiff(o2, p2)), r2]));
      add(format('  Distance to sphere %d is %.5f (vs. measured %.5f)',
       [3,vnorm(vdiff(o2, p3)), r3]));
      add(format('  Distance to sphere %d is %.5f (vs. measured %.5f)',
       [4,vnorm(vdiff(o2, p4)), r4]));
    end;
  end;
end;

begin  //@main

  loadForm;
  Application.Icon.handle:= LoadIcon(hInstance,'THEBALLICON');
  
End.

{
Unit UMatrix
Procedure Determinant( Dimen : integer; Data : TNmatrix; var Det : Float; var Error : byte)');
Procedure Inverse2( Dimen : integer; Data : TNmatrix; var Inv : TNmatrix; var Error : byte)');
 Procedure Gaussian_Elimination(Dimen:integer;Coefficients:TNmatrix;Constants:TNvector;var Solution:TNvector;var Error:byte);
 Procedure Partial_Pivoting(Dimen:integer; Coefficients:TNmatrix;Constants:TNvector; var Solution:TNvector;var Error:byte);
 Procedure LU_Decompose(Dimen:integer;Coefficients:TNmatrix;var Decomp:TNmatrix;var Permute:TNmatrix;var Error:byte);
 Procedure LU_Solve(Dimen: integer;var Decomp TNmatrix;Constants:TNvector;var Permute:TNmatrix;var Solution:TNvector;var Error:byte);
 Procedure Gauss_Seidel( Dimen : integer; Coefficients : TNmatrix; Constants : TNvector; Tol : Float; MaxIter : integer; var Solution : TNvector; var Iter : integer; var Error : byte)');
end; 

Solution 1: 5.00 5.00 5.00
  Distance to sphere 1 is 6.928 (radius 6.928)
  Distance to sphere 2 is 6.403 (radius 6.403)
  Distance to sphere 3 is 6.403 (radius 6.403)
Solution 2: 5.00 -3.00 5.00
  Distance to sphere 1 is 6.928 (radius 6.928)
  Distance to sphere 2 is 6.403 (radius 6.403)
  Distance to sphere 3 is 6.403 (radius 6.403)

Solution 1: 4.97 5.03 5.00
  Distance to sphere 1 is 6.928 (radius 6.928)
  Distance to sphere 2 is 6.403 (radius 6.403)
  Distance to sphere 4 is 3.464 (radius 3.464)
Solution 2: 5.03 4.97 5.00
  Distance to sphere 1 is 6.928 (radius 6.928)
  Distance to sphere 2 is 6.403 (radius 6.403)
  Distance to sphere 4 is 3.464 (radius 3.464)

Solution 1: 5.00 4.97 5.03
  Distance to sphere 1 is 6.928 (radius 6.928)
  Distance to sphere 3 is 6.403 (radius 6.403)
  Distance to sphere 4 is 3.464 (radius 3.464)
Solution 2: 5.00 5.03 4.97
  Distance to sphere 1 is 6.928 (radius 6.928)
  Distance to sphere 3 is 6.403 (radius 6.403)
  Distance to sphere 4 is 3.464 (radius 3.464)

Solution 1: 4.53 5.71 4.53
  Distance to sphere 2 is 6.403 (radius 6.403)
  Distance to sphere 3 is 6.403 (radius 6.403)
  Distance to sphere 4 is 3.464 (radius 3.464)
Solution 2: 5.00 5.00 5.00
  Distance to sphere 2 is 6.403 (radius 6.403)
  Distance to sphere 3 is 6.403 (radius 6.403)
  Distance to sphere 4 is 3.464 (radius 3.464)
Sum of coordinate differences:
  Solution 1: 1.75172, Solution #2: 24.05681
Using Solution 1 set
Solution 1: 5.00 5.00 5.00
  Distance to sphere 1 is 6.92800 (vs. measured 6.92800)
  Distance to sphere 2 is 6.40300 (vs. measured 6.40300)
  Distance to sphere 3 is 6.40300 (vs. measured 6.40300)
  Distance to sphere 4 is 3.46390 (vs. measured 3.46400)
}
